<?php 
class RegularExpression

{    

	//Nəqliyyat vasitəsinin nömrəsini extract etmək üçün funksiya
    public function findPlate($plate){

        //Bütün xüsusi simvolları yığışdıraq(-\`, və s.)
		$plate=preg_replace('/[^A-Za-z0-9]/', '', $plate);

		//Nömrə bir neçə formada ola bilər:
		$patterns[]='/[0-9]{2}[a-zA-Z]{2}[0-9]{3}/';       //1. 10AA999
		$patterns[]='/[0-9]{2}[a-zA-Z]{1}[0-9]{3}/';   	   //2. 10B999
		$patterns[]='/[a-zA-Z]{1}[0-9]{6}/';   		       //3. H021222
		$patterns[]='/[a-zA-Z]{2}[0-9]{3}[a-zA-Z]{2}/';    //4. GM888MG
		$patterns[]='/[0-9]{3}[a-zA-Z]{2}[0-9]{3}/';       //5. 110FX115

		foreach ($patterns as $pattern) {
			preg_match($pattern,$plate,$match);
			if(!empty($match))
				return $match[0];
		}

		return "undefined";
    }
}

?>