<?php 

ini_set('display_errors', true);
session_start();
ob_start();
include 'getholcimtoken.php';
include 'dailyviolations.php';
include 'wialon.php';
include 'Wialon/wialon.php';
include_once 'database/dbpostgresql.php';
include 'createexcel.php';
include __DIR__ . "/sendMail.php";


$tokenholcim=new getholcimtoken();
$token=$tokenholcim->gettoken();
$_SESSION['wialon']=new WialonApi($token);

if (!$_SESSION['admin']) 

{  
  header('Location:index.php');
}


if (isset($_POST['execute'])) 
{
	$from=$_POST['from'];
	$to=$_POST['to'];
	$postedemail=$_POST['postedemail'];
	$groupid=$_POST['vehicle_group'];
 
	date_default_timezone_set('Asia/Baku');
	$anytimebegin = date('Y-m-d',strtotime($from));
	$anytimeend = date('Y-m-d',strtotime($to));


	//1.Seçilmiş Qrupa daxil olan maşınların wailon id-lərini əldə edək
	//2.Open street map-e esaslanmish suret heddi ashmalarini seçilmiş zaman intervalı üçün elde edek
	//3.Open street map-e esaslanmish melumatların içinden YALNIZ seçilmiş qrupun maşınlarına aid olanları filter edib, nəticə alaq
	//4.Nəticənin excel versiyasını düzəldək
	//5.Nəticənin excel versiyasını seçilmiş emailə göndərək



	//1.---BEGIN---Qrupa daxil olan maşınların wailon id-lərini əldə edək
	$unitsofselectedgroup=null;
	if($groupid!=null){
		$unitsofselectedgroup=UnitOfGroup($groupid);

	}
	//1.---END---Qrupa daxil olan maşınların wailon id-lərini əldə edək

	//2.---BEGIN---Open street map-e esaslanmish suret heddi ashmalarini seçilmiş zaman intervalı üçün elde edek
	$OSMtimebegin = date('Y-m-d 00:00:00',strtotime($from));
  	$OSMtimeend = date('Y-m-d 23:59:59',strtotime($to));
  	$OSMtimewhere= "timestamp_start>='".$OSMtimebegin."' and timestamp_start<='".$OSMtimeend."' and duration>0";
  	$dbOSMviolation= new DatabasePG('134.19.214.58',5455,'holcim_roads','postgres','49XyMsJ!rkrg72vd9x');
 	$dbOSMviolationdatas=$dbOSMviolation->select("raw_violations_db",$OSMtimewhere,"timestamp_start");

	if(!empty($dbOSMviolationdatas)){
	    //Device-nin id-nə görə qruplaşdıraq
	    $groupbydeviceidOSM = array();
	    foreach ($dbOSMviolationdatas as $value ) {
	        if (isset($value['ident'])) {
	            if($value['ident']!=null){
	                $value['timestamp_start']=date('Y-m-d H:i:s',strtotime( $value['timestamp_start'])+14400);
	                $value['timestamp_end']=date('Y-m-d H:i:s',strtotime( $value['timestamp_end'])+14400);
	                $groupbydeviceidOSM[$value['ident']][] = $value;
	            }  
	        }
	    }
	}
	//2.---END---Open street map-e esaslanmish suret heddi ashmalarini seçilmiş zaman intervalı üçün elde edek

	

	//3.---BEGIN---Open street map-e esaslanmish melumatların içindin YALNIZ seçilmiş qrupun maşınlarına aid olanları filter edib, nəticə alaq
	$result=array();
	if(!empty($unitsofselectedgroup[1]) && !empty($groupbydeviceidOSM)){
		foreach ($unitsofselectedgroup[1] as $wialonkey => $wialonvalue) {
			//OSM-dən bizə yalnız cihazın real id-si('861359039059819') göndərilir. Qrup seçdikdə isə bizdə yalnız cihazların wialondakı id-si olur. Onların eyniləşdirmək üçün biz wialondakı id-yə uyğun cihazın bütün məlumatlarını yenidən wialona müraciət edərək əldə etməliyik. Həmin məlumatların içindən isə cihazın real id-ni tapa bilərik.
			$unitinfo=$_SESSION['wialon']->unitinfo_by_id($wialonvalue);
			foreach ($groupbydeviceidOSM as $OSMkey => $OSMvalue) {
				if($OSMvalue[0]['ident']==$unitinfo['item']['uid']){
					$result[$unitinfo['item']['nm']]=$OSMvalue;
				}	
			}

		}
	}
	// print_r('<pre>');
	// print_r($result);
	// print_r('</pre>');
	// die();
	//3.---END---Open street map-e esaslanmish melumatların içindin YALNIZ seçilmiş qrupun maşınlarına aid olanları filter edib, nəticə alaq

	if (!empty($postedemail)) {

		$resultrunreport=runreport($from,$to,$result);

		if($resultrunreport!=null){

			$resultsendingmail=runsendingmail($postedemail,$resultrunreport,$from,$to);

			if($resultsendingmail){

				$_SESSION["success"]="Successful!";

				header('Location:Frontside/roadlimitviolations.php');

			}else{

				$_SESSION["error"]="Email Problem!";

				header('Location:Frontside/roadlimitviolations.php');

			}

			

		}

		else{

			$_SESSION["error"]="Network Problem!";

			header('Location:Frontside/roadlimitviolations.php');

		}

	}

	else{

	$_SESSION["error"]="Please enter e-mail address!";

	header('Location:Frontside/roadlimitviolations.php');

	}

}

else
{
header('Location:Frontside/roadlimitviolations.php');
}
    
// Group id-ə uyğun unitləri qaytarır
function UnitOfGroup($group_id)
{

    $unit_group=$_SESSION['wialon']->unit_group();
    $unitidANDgroupname=array();
    foreach ($unit_group as $key => $value) 
    {
		if ($value["id"]==$group_id) 
		{   
			// echo "unit count =".count($value['u'])."<br>";
			array_push($unitidANDgroupname, $value['nm']);
			array_push($unitidANDgroupname, $value['u']);
			return $unitidANDgroupname;
		}
    }
}



//1.Istənilən tarix üçün Road Limit Violations(Yollara görə qayda pozuntularına) aid materialları excelə yığaq

function runreport($anytimebegin,$anytimeend,$result){

	$runanytimecreatexcel=new createexcel();

	return $answerexcel=$runanytimecreatexcel->runroadlimitviolationsreportcreatexcel($anytimebegin,$anytimeend,$result);	

}





//2.Istənilən tarix üçün hazırlanmış exceli emaillərə göndərək.(Amma əvvəlcə bundan qabaqki mərhələinin müvəffəqiyyətlə tamamlanıb-tamamlanmadığını yoxlayaq)

function runsendingmail($postedemail,$answerexcel,$anytimebegin,$anytimeend){

	$emailsnames=array();

	array_push($emailsnames, $postedemail);

	$emails=$emailsnames;

	$fileName=$answerexcel;

	sendMail($emails, $fileName, "ROAD LIMIT VIOLATIONS",$anytimebegin, $anytimeend,$path=false);

	return true;

}





?>