<?php
ini_set('display_errors', true);
session_start();

if (!$_SESSION['admin']) 
{  
  header('Location:index.php');
}

date_default_timezone_set('Asia/Baku');
$datepicker = strtotime("midnight", time());
$datepickerFrom = $datepicker;
$datepickerTo = $datepicker + 3600 * 24 - 1;


$yesterdaybegin = date('Y-m-d',time());

include_once '../database/db.php';
include '../wialon.php';
include '../Wialon/wialon.php';
include '../getholcimtoken.php';
include "header.php";


$tokenholcim=new getholcimtoken();
$token=$tokenholcim->gettoken();
$wialon=new WialonApi($token);
$unit_group=$wialon->unit_group();

if($_SESSION['level']==2){
    $new_unit_group=array();
    if($_SESSION['user_vehicle_groups']!=NuLL){
        foreach($_SESSION['user_vehicle_groups'] as $user_vehicle_group_value ){
            foreach($unit_group as $unit_group_value ) {
                if($user_vehicle_group_value==$unit_group_value['id']){
                    array_push($new_unit_group, $unit_group_value);
                }
            }
        }
        $unit_group=$new_unit_group;
    }
}
?>

<!-- <!DOCTYPE html>
<html lang="en" >
<head>
    <meta charset="UTF-8">
    <title>Login</title>
    <link rel="stylesheet" href="../Public/css/bootstrap.min.css">
    <link rel="stylesheet" href="../Public/css/custom.css">
</head> -->



<div class="wrapper">

<div class="container">

	<h1>Driver Score Card Report</h1>

	<h4>Choose group, date interval and type e-mail address</h4>

	<form class="form" action="../ragreport.php" method="POST">

		<div class="form-group row">

			<label for="" class="col-sm-3 form-control-label" style="text-align:left">Vehicle Group:</label>

			<div class="col-sm-9">

				<select class="form-control raginput" id="select-vehicle-group">

					<?php foreach ($unit_group as  $item){

					?>

					<option data-id="<?=$item['id']?>"><?=$item['nm']?></option>

					<?php } ?>

					<input type="hidden" name="vehicle_group" value="<?=$unit_group[0]['id']?>">

				</select>

			</div>

		</div>


		<div class="form-group row">

			<label for="" class="col-sm-3 form-control-label" style="text-align:left">Date From:</label>

			<div class="col-sm-9">

				<input type="date" class="form-control raginput" name="timeFrom" value="<?=$yesterdaybegin?>">

			</div>

		</div>

		<div class="form-group row">

			<label for="" class="col-sm-3 form-control-label" style="text-align:left">Date To:</label>

			<div class="col-sm-9">

				<input type="date" class="form-control raginput" name="timeTo" value="<?=$yesterdaybegin?>">

			</div>

		</div>

		<div class="form-group row">

			<label for="" class="col-sm-3 form-control-label" style="text-align:left">Email:</label>

			<div class="col-sm-9">

				<input type="email" class="form-control raginput" placeholder="e-mail" name="email">

			</div>

		</div>

		<div class="row">

			<p class="col-sm-10 alert_mail" style="float: right;color: red;display: none;"><strong>Alert!</strong>  Please, fill email !</p>

		</div>

		<div class="form-group row">

			<label for="" class="col-sm-3 form-control-label" style="text-align:left" >Send:</label>

			<div class="col-sm-9">

				<button type="submit" name="execute"  class="ragexecute" id="login-button">Execute</button>

			</div>

		</div>

	</form>

	<div class="loader" style="display:none;text-align: center;margin-left: 160px;">
			<img width="450" class="img-responsive" src="load.gif" style="margin-top: 0;height: 90px;width: 100px">
	</div>

</div>



		


<?php 

include "footer.php";

?>



