<?php
ini_set('display_errors', true);
session_start();

if (!$_SESSION['admin']) 
{  
  header('Location:index.php');
}

date_default_timezone_set('Asia/Baku');
$datepicker = strtotime("midnight", time());
$datepickerFrom = $datepicker;
$datepickerTo = $datepicker + 3600 * 24 - 1;

include_once '../database/db.php';
include '../wialon.php';
include '../Wialon/wialon.php';
include '../getholcimtoken.php';
include "header.php";


$tokenholcim=new getholcimtoken();
$token=$tokenholcim->gettoken();
$wialon=new WialonApi($token);
$unit_group=$wialon->unit_group();
?>


<div class="wrapper">

<div class="container">

	<h1>Delivery Report By Imported Excel</h1>

	<h4>Choose group, date interval and type e-mail address</h4>

	<form class="form" action="../comparewialonandvisitedimportexcels.php" method="POST">

		<div class="form-group row">

			<label for="" class="col-sm-3 form-control-label" style="text-align:left">Vehicle Group:</label>

			<div class="col-sm-9">

				<select class="form-control importexcelinput" id="select-vehicle-group">

					<?php foreach ($unit_group as  $item){

					?>

					<option data-id="<?=$item['id']?>"><?=$item['nm']?></option>

					<?php } ?>

					<input type="hidden" name="vehicle_group" value="<?=$unit_group[0]['id']?>">

				</select>

			</div>

		</div>


		<div class="form-group row">

			<label for="" class="col-sm-3 form-control-label" style="text-align:left">Date From:</label>

			<div class="col-sm-9">

				<input type="datetime-local" class="form-control importexcelinput" name="timeFrom" value="<?=date("Y-m-d\TH:i", $datepickerFrom)?>">

			</div>

		</div>

		<div class="form-group row">

			<label for="" class="col-sm-3 form-control-label" style="text-align:left">Date To:</label>

			<div class="col-sm-9">

				<input type="datetime-local" class="form-control importexcelinput" name="timeTo" value="<?=date("Y-m-d\TH:i", $datepickerTo)?>">

			</div>

		</div>

		<div class="form-group row">

			<label for="" class="col-sm-3 form-control-label" style="text-align:left">Email:</label>

			<div class="col-sm-9">

				<input type="email" class="form-control importexcelinput" placeholder="e-mail" name="email">

			</div>

		</div>

		<div class="row">

			<p class="col-sm-10 alert_mail" style="float: right;color: red;display: none;"><strong>Alert!</strong>  Please, fill email !</p>

		</div>

		<div class="form-group row">

			<label for="" class="col-sm-3 form-control-label" style="text-align:left" >Send:</label>

			<div class="col-sm-9">

				<button type="submit" name="execute"  class="importexcelexecute" id="login-button">Execute</button>

			</div>

		</div>

	</form>

	<div class="loader" style="display:none;text-align: center;margin-left: 160px;">
			<img width="450" class="img-responsive" src="load.gif" style="margin-top: 0;height: 90px;width: 100px">
	</div>

</div>



		


<?php 

include "footer.php";

?>



