<?php 
ini_set('display_errors', true);
date_default_timezone_set('Asia/Baku');
session_start();
include 'wialon.php';
include 'Wialon/wialon.php';
include 'getholcimtoken.php';
include_once 'database/dbpostgresql.php';

//Loglar
$ldate = date('Y-m-d H:i:s');
$message=$ldate." - Wialon and OSM devices comparison STARTED \n";
$myFile=fopen("/home/aasfle5/holcim.fatigue.aplusa-security.com/holcim/holcim.txt", "a+") or die("Unable to open file!");
fwrite($myFile,$message);
fclose($myFile);
//Loglar



//Bu bölmənin məqsədi OSM-in device bazası ilə Wialonun device bazasını müqayisə edib eyniləşdirməkdir.
//OSM-dəki device table-da avadanlığın real id-si və nv-nin tipi saxlanılır. Ona görə də müqayisə zamanı bizə Wialondakı avadanlıqların real id-si və nv-nin tipi lazım olacaq 


//Wialondan bütün obyektlərin id-ni, cihazların real id-ni, nv-nin tipini əldə edək(Qeyd:Əgər wialon sistemində nv-nin  xarakteristika bölməsinin tip yeşiyində nəsə yazılıbsa bu "truck", heçnə yazılmayıbsa bu "light" deməkdir)
$tokenholcim=new getholcimtoken();
$token=$tokenholcim->gettoken();
$_SESSION['wialon']=new WialonApi($token);
$wialondevicesdatas=$_SESSION['wialon']->allUnitsWithRealDeviceIdAndVehicleType();

//OSM-dəki avadablıqları əldə edək
$dbOSMdevices= new DatabasePG('134.19.214.58',5455,'holcim_roads','postgres','49XyMsJ!rkrg72vd9x');
$dbOSMdevicesdatas=$dbOSMdevices->select("devices");

//Müqayisə edək və yeni avadanlıqları OSM-dəki device table-na əlavə edək. Bundan əlavə bəzən Wialonda nv-nin tipi dəyişə bilər,ona görə də bu dəyişiklikləri də nəzərə alıb mövcud olan device-ları yeniləməliyik.
$findedinOSM=false;
foreach ($wialondevicesdatas as $wialonvalue) {
	if($dbOSMdevicesdatas!=null){
		foreach ($dbOSMdevicesdatas as $dbOSMvalue) {
		//Ilk növbədə yoxlayaq ki, Wialondakı avadanlıq OSM-də var ya yox
			if($wialonvalue['device_id']==$dbOSMvalue['device_id']){
				$findedinOSM=true;
				//Varsa, nv-nin tipini yoxlayaq
				if($wialonvalue['vehicle_type']!=$dbOSMvalue['vehicle_type']){
					//Wialondakı avadanlığın tipiylə OSM-dəki tip eyni deyilsə həmin avadanlığın tipini OSM-də update edirik
					$dbOSMdevicesupdate= new DatabasePG('134.19.214.58',5455,'holcim_roads','postgres','49XyMsJ!rkrg72vd9x');
					$data= array('vehicle_type' =>$wialonvalue['vehicle_type']);
					$dbOSMdevicesupdate->update("devices",$data,$dbOSMvalue['id']);
					print_r("<pre>");
					print_r("OSM de var lakin tipi ferqlidi, UPDATE EDEK:".$wialonvalue['device_id']."---".$wialonvalue['vehicle_type']);
					print_r("</pre>");
					break;
				}
				else{
					//Wialondakı avadanlığın tipiylə OSM-dəki tip eynidirsə heçnə etmirik
					print_r("<pre>");
					print_r("OSM de var ve tipi de eynidir, yeni hecne etmirik:".$wialonvalue['device_id']."---".$wialonvalue['vehicle_type']);
					print_r("</pre>");
					break;
				}
			}
		}
	}
	
	if($findedinOSM==false){
		//Wialondakı avadanlıq OSM-də yoxdursa onu yeni avadanlıq kimi OSM-də create edirik
		$dbOSMdevicescreate= new DatabasePG('134.19.214.58',5455,'holcim_roads','postgres','49XyMsJ!rkrg72vd9x');
		$data= array('device_id' =>$wialonvalue['device_id'],'vehicle_type' =>$wialonvalue['vehicle_type']);
		$dbOSMdevicescreate->insert("devices",$data);
		print_r("<pre>");
		print_r("OSM de yoxdu INSERT EDEK:".$wialonvalue['device_id']."---".$wialonvalue['vehicle_type']);
		print_r("</pre>");
	}
	$findedinOSM=false;
}

//Loglar
$ldate = date('Y-m-d H:i:s');
$message=$ldate." - Wialon and OSM devices comparison ENDED \n";
$myFile=fopen("/home/aasfle5/holcim.fatigue.aplusa-security.com/holcim/holcim.txt", "a+") or die("Unable to open file!");
fwrite($myFile,$message);
fclose($myFile);
//Loglar

?>