<?php 
print "Hello, World0";
ini_set('display_errors', true);
date_default_timezone_set('Asia/Baku');
session_start();
include 'wialon.php';
include 'Wialon/wialon.php';
include 'getholcimtoken.php';
include_once 'database/db.php';
include 'createexcel.php';
include __DIR__ . "/sendMail.php";
require 'Classes/regularexpression.php';

$regularExpression = new RegularExpression();
$tokenholcim=new getholcimtoken();
$token=$tokenholcim->gettoken();
$_SESSION['wialon']=new WialonApi($token);

if (!$_SESSION['admin']) 
{  
  header('Location:index.php');
}

//Bu bölmənin məqsədi Database-ə Import olunmuş excellə Wialondaki hesabatları(HOLCIM_VISIT) müqayisə etməkdir
//Database-ə Import olunmuş excel faylında NV-nin gedəcəyi təyinat nöqtələri(Geozonalar) qeyd olunmuşdur. 
//Wialondakı hesabatdan istifadə edərək biz:
//1.NV-nin həmin nöqtələrə gedib-gedmədiyini təyin etməliyik.
//2.NV-nin seçilmiş nöqtlərdən kənarda dayanma hallarını təyin etməliyik
//3.NV-nin seçilmiş nöqtlərdən kənarda kompressor sensorunu işə salma hallarını təyin etməliyik

$from=$_POST['timeFrom'];
$to=$_POST['timeTo'];
$postedemail=$_POST['email'];
$groupid=$_POST['vehicle_group'];
// $groupid=18625327;

// 2024-07-26T00:00
// 2024-07-26T23:59
// akhbvr@gmail.com
// 27251974
 
$anytimebegin = date('Y-m-d',strtotime($from));
$anytimeend = date('Y-m-d',strtotime($to));


// $anytimebegin = "2019-09-01";
// $anytimeend = "2019-09-30";

//---BEGIN---Bütün zonaları əldə edək
$allzones=$_SESSION['wialon']->geofences();
//---END---Bütün zonaları əldə edək
//---BEGIN---Bütün NV-nin məlumatlarını əldə edək
$allunits=$_SESSION['wialon']->allDataOfUnits();
//---END---Bütün NV-nin məlumatlarını əldə edək

//---BEGIN---Database-ə Import olunmuş excel-in seçilmiş zaman intervalı üçün məlumatlarını əldə edək
$importExcelDatewhere= "loading_ts_date>='".$anytimebegin."' and loading_ts_date<='".$anytimeend."'";
$dbimportExcelDate= new Database("localhost", "aasfle5_HolcimFatigueUser", "ggUsjQl&Oa.[", "aasfle5_HolcimFatigue");
$orderBy="plate, loading_ts_date";
$dbimportExcelDatedatas=$dbimportExcelDate->select("VisitedExcelImport",$importExcelDatewhere,$orderBy);

//---BEGIN---NV-nin nömrəsinə,tarixə və zonaya görə qruplaşdıraq
if(!empty($dbimportExcelDatedatas)){
    $groupbyplate = array();
    foreach ( $dbimportExcelDatedatas as $value ) {
        if (isset($value['plate'])) {
            if($value['plate']!=null){
                $groupbyplate[$value['plate']][$value['loading_ts_date']][$value['shipto_sap_no']][] = $value;
            }  
        }
    }
}
//---END---NV-nin nömrəsinə,tarixə və zonaya görə qruplaşdıraq
//---END---Database-ə Import olunmuş excel-in seçilmiş zaman intervalı üçün məlumatlarını əldə edək


//---BEGIN---Qrupa daxil olan NV-nin wailon id-lərini əldə edək
$unitsofselectedgroup=null;
if($groupid!=null){
	$unitsofselectedgroup=UnitOfGroup($groupid);
}
//---END---Qrupa daxil olan NV-nin wailon id-lərini əldə edək

//---BEGIN---Bütün NV-nin məlumatları arasından qrupa daxil olanları seçək
$comparednuits=[];
foreach ($unitsofselectedgroup[1] as $unitidofgroup) {
	foreach ($allunits as $unitofallunit) {
		if($unitidofgroup==$unitofallunit['id']){
			$unitofallunit['nm']=$regularExpression->findPlate($unitofallunit['nm']);
			array_push($comparednuits, $unitofallunit);
		}
	}
}
//---END---Bütün NV-nin məlumatları arasından qrupa daxil olanları seçək


//---BEGIN---Seçilmiş qrupdakı NV-ləri İmport olunmuş excel-də yoxdursa,onları hesabatdan istisna etməliyik
$filteredunits=[];
foreach ($comparednuits as $wialonvalue) {
	foreach ($groupbyplate as $importexcelkey => $importexcelvalue) {
		if($wialonvalue['nm']==$importexcelkey){
			$filteredunits[$wialonvalue['id']]=$importexcelvalue;
		}
	}
}
//---END---Seçilmiş qrupdakı NV-ləri İmport olunmuş excel-də yoxdursa,onları hesabatdan istisna etməliyik

//Find geozones wialon id by description
//Update report
//Execute report
//Analisy result
//Add result to list
$data_for_report=[];
$counter=0;
foreach ($filteredunits as $platekey => $platevalue) {
	foreach ($platevalue as $datekey => $datevalue) {
	    $counter=$counter+1;
		$each_data_for_report=[];
		$gezones=[];
		$gezones_by_zonekey=[];
		foreach ($datevalue as $zonekey => $zonevalue) {
			$zone_info=FindGeoIdByDescription($allzones,$zonekey);
			if($zone_info!=null){
			    if(!in_array($zone_info,$gezones)){
				    array_push($gezones, $zone_info);
			    }
			    if(!in_array($zonekey,$gezones_by_zonekey)){
				    array_push($gezones_by_zonekey, $zonekey);
			    }
			}
		}
		
	
		if($gezones!=null){
			$report_updated=$_SESSION['wialon']->updateReport(14147503,11,$gezones);
// 			$report_created=$_SESSION['wialon']->createReport(14147503,$gezones);
			
// 			print_r("REPORT CREATED BRGIN");
// 			print_r($report_created); 
// 			print_r("REPORT CREATED END");
// 			die();
			
// 			$x=$_SESSION['wialon']->getReportInfo(14147503,11);
// 			print_r("REPORT INFO BRGIN");
// 			print_r($x); 
// 			print_r("REPORT INFO END");
			
			if (!array_key_exists("error",$report_created)){
				$datekeyFrom = date('d.m.Y 00:00',strtotime($datekey));
				$datekeyTo = date('d.m.Y 23:59',strtotime($datekey. ' + 1 days'));
				
			
				
				$get_exec_geo_report_first=$_SESSION['wialon']->getExecGeozonesReport($platekey,$datekeyFrom,$datekeyTo,11);
				sleep(1);
				$get_exec_geo_report_second=$_SESSION['wialon']->getExecGeozonesReport($platekey,$datekeyFrom,$datekeyTo,11);
				$get_exec_geo_report=$_SESSION['wialon']->getExecGeozonesReport($platekey,$datekeyFrom,$datekeyTo,11);
				
				
				// $get_exec_geo_report=$_SESSION['wialon']->getExecGeozonesReport($platekey,$datekeyFrom,$datekeyTo,$report_created[0]);
				// print_r("REPORT BRGIN");
			 //   print_r($get_exec_geo_report); 
			 //   print_r("REPORT END");
				// $report_deleted=$_SESSION['wialon']->deleteReport(14147503,$report_created[0]);
				// die();
				
				// $y=$_SESSION['wialon']->getReportInfo(14147503,11);
				// print_r("REPORT INFO AFTER EXECUTE BRGIN");
			 //   print_r($y); 
			 //   print_r("REPORT INFO AFTER EXECUTE END");
				
				// $plate=$platevalue[key($platevalue)][key($platevalue[key($platevalue)])][0]['plate'];

				$visited_zones=$get_exec_geo_report[1][0];
				$idle=$get_exec_geo_report[1][1];
				$compressor=$get_exec_geo_report[1][2];
				
				

                print_r("***************BEGIN*************   ");
                print_r("Plate:".$get_exec_geo_report[1][0][0]['r'][0]['c'][0]);
                print_r("   Idle:".$idle[0]['c'][3]);
                print_r("   Compressor:".$compressor[0]['c'][4]."   Descriptions:");
                print_r($gezones_by_zonekey);
                print_r("<pre>");
                print_r($gezones);
                print_r("</pre>");
                print_r("<pre>");
                print_r($visited_zones);
                print_r("</pre>");
                print_r("   ****************END************");
                // die();

				
				
				
				

				// $check_visited_zones=CheckVisitedZones($gezones,$visited_zones);
				$check_visited_zones=CheckVisitedZones($gezones_by_zonekey,$visited_zones);
				$check_idle=CheckIdle($idle);
				if($check_idle=="0:00:00"){
					$check_idle="";
				}
				$check_compressor=CheckCompressor($compressor);
				if($check_compressor=="0:00:00"){
					$check_compressor="";
				}	
			}
		}
		else{
			$check_visited_zones=array("status"=>"NOT FOUND","geozones"=>"NOT FOUND");
			$check_idle="NOT FOUND";
			$check_compressor="NOT FOUND";

		}
		foreach ($datevalue as $zonekey => $zonevalue) {
			foreach ($zonevalue as $orderkey => $ordervalue) {
				$each_data_for_report['loading_ts_date']=$ordervalue['loading_ts_date'];
				$each_data_for_report['loading_ts']=$ordervalue['loading_ts'];
				$each_data_for_report['order_number']=$ordervalue['order_number'];
				$each_data_for_report['lds_delivery_note_no']=$ordervalue['lds_delivery_note_no'];
				$each_data_for_report['sold_to']=$ordervalue['sold_to'];
				$each_data_for_report['city']=$ordervalue['city'];
				$each_data_for_report['ship_to']=$ordervalue['ship_to'];
				$each_data_for_report['shipto_sap_no']=$ordervalue['shipto_sap_no'];
				$each_data_for_report['vehicle']=$ordervalue['vehicle'];
				$each_data_for_report['plate']=$ordervalue['plate'];
				if($check_visited_zones['status']!="NOT FOUND"){
					if(in_array($ordervalue['shipto_sap_no'], $check_visited_zones['geozones'])){
						$each_data_for_report['check_visited_zones']="+";
					}
					else{
						$each_data_for_report['check_visited_zones']="-";
					}
					
				}else{
					$each_data_for_report['check_visited_zones']="NOT FOUND";
				}
				$each_data_for_report['check_idle']=$check_idle;
				$each_data_for_report['check_compressor']=$check_compressor;
				array_push($data_for_report, $each_data_for_report);
			}
		}
	}
}


$runreportresult=runreport($anytimebegin,$anytimeend,$data_for_report);
if($runreportresult!=null){
	runsendingmail($postedemail,$runreportresult,$anytimebegin,$anytimeend);
}
else{

	print_r("<pre>");
    print_r("Exceldə problem var");
    print_r("</pre>");
    die();
}

//---BEGIN---Istənilən tarix üçün aldığımız nəticəyə aid materialları excelə yığaq
function runreport($anytimebegin,$anytimeend,$result){
	$runanytimecreatexcel=new createexcel();
	return $answerexcel=$runanytimecreatexcel->runcomparewialonandvisitedimportexcelscreatexcel($anytimebegin,$anytimeend,$result);	
}
//---END---Istənilən tarix üçün aldığımız nəticəyə aid materialları excelə yığaq


//---BEGIN---Istənilən tarix üçün hazırlanmış exceli emaillərə göndərək.(Amma əvvəlcə bundan qabaqki mərhələinin müvəffəqiyyətlə tamamlanıb-tamamlanmadığını yoxlayaq)
function runsendingmail($postedemail,$answerexcel,$anytimebegin,$anytimeend){
	$emailsnames=array();
	array_push($emailsnames, $postedemail);
	$emails=$emailsnames;
	$fileName=$answerexcel;
	sendMail($emails, $fileName, "Delivery Report by Imported Excel",$anytimebegin, $anytimeend,$path=false);
	return true;
}
//---END---Istənilən tarix üçün hazırlanmış exceli emaillərə göndərək.(Amma əvvəlcə bundan qabaqki mərhələinin müvəffəqiyyətlə tamamlanıb-tamamlanmadığını yoxlayaq)




//---BEGIN---Köməkçi funksiyalar
// Group id-ə uyğun unitləri qaytarır
function UnitOfGroup($group_id)
{
    $unit_group=$_SESSION['wialon']->unit_group();
    $unitidANDgroupname=array();
    foreach ($unit_group as $key => $value) 
    {
		if ($value["id"]==$group_id) 
		{   
			array_push($unitidANDgroupname, $value['nm']);
			array_push($unitidANDgroupname, $value['u']);
			return $unitidANDgroupname;
		}
    }
}


function FindGeoIdByDescription($zones,$description){
    
// 	$key = array_search($description, array_column($zones,'description'));
	
	$key=False;
	foreach ($zones as $item_key => $item_value) {
	    $item_value_description_replace=str_replace(" ","",$item_value["description"]);
        $item_value_description_replace=str_replace("\r","",$item_value_description_replace);
        $item_value_description_replace=str_replace("\n","",$item_value_description_replace);
	    $description_array=explode(",",$item_value_description_replace);
	    
	    
        print_r("----------FindGeoIdByDescriptionBEGIN----------");
        print_r("description : ".$description);
        print_r("  item_value_description_replace: ".$item_value_description_replace);
        print_r("<pre>");
        print_r($description_array);
        print_r("</pre>");
        print_r("----------FindGeoIdByDescriptionEND----------");
        
        

     	foreach ($description_array as $inner) {
     		if($inner==$description){
     		    print_r("----------KEYBEGIN----------");
     		    print_r("inner : ".$inner);
                print_r("description : ".$description);
                print_r("Key: ".$item_key);
                print_r("----------KEYEND----------");
     		    $key=$item_key;
            }
     	}
    }
	if($key!== False){
	    
	    
		$result = $zones[$key];
// 		$description_length=strlen($description);
// 		$result_length=strlen($result['description']);
// 		if($description_length==$result_length){
// 			$result=$result;
// 		}else{
// 			$result=null;
// 		}

 	}
 	else{
 		$result=null;
 	}
	return $result;
}


//Check selected geozones visited or not
function CheckVisitedZones($must_visited_gezones,$visited_zones){
	//1.Collect geozones descriptions in array
	//2.Collect visited geozones descriptions from  report in array
	//3.Check this two array equal or not 
	
	$must_geozones_description=$must_visited_gezones;
	$visited_zone_descriptions=[];
	if(!empty($visited_zones)){
		foreach ($visited_zones as $visited_zone) {
		    $visited_zone_description_replace=str_replace(" ","",$visited_zone['r'][0]['c'][2]);
            $visited_zone_description_replace=str_replace("\r","",$visited_zone_description_replace);
            $visited_zone_description_replace=str_replace("\n","",$visited_zone_description_replace);
		    $visited_zone_to_array=explode(",",$visited_zone_description_replace);
		    foreach ($visited_zone_to_array as $visited_zone_inner) {
		        array_push($visited_zone_descriptions, $visited_zone_inner);
		    }
		}
	}
	
	
// 	$must_geozones_description=[];
// 	if(!empty($must_visited_gezones)){
// 		foreach ($must_visited_gezones as $geozone) {
// 			array_push($must_geozones_description, $geozone['description']);
// 		}
// 	}


// 	$visited_zone_descriptions=[];
// 	if(!empty($visited_zones)){
// 		foreach ($visited_zones as $visited_zone) {
// 			array_push($visited_zone_descriptions, $visited_zone['r'][0]['c'][2]);
// 		}
// 	}

      
	if(!empty($must_geozones_description) && !empty($visited_zone_descriptions)){
		$arraysAreEqual = ($must_geozones_description == $visited_zone_descriptions);
		if($arraysAreEqual==true){
			$result['status']="ALL_GEOZONES_VISITED";
			$result['geozones']=$visited_zone_descriptions;
			return $result;
		}else{
			$arraysSomeValueAreEqual=array_intersect($must_geozones_description,$visited_zone_descriptions);
			$result['status']="SOME_GEOZONES_VISITED";
			$result['geozones']=$arraysSomeValueAreEqual;
			return $result;
		}
	}
	$result['status']=null;
	$result['geozones']=null;
	return $result;
}


//Check vehicle make idling out of geozones
function CheckIdle($idle){
	return $result=$idle[0]['c'][3];
}


//Check vehicle activate compressor out of geozones
function CheckCompressor($compressor){
	return $result=$compressor[0]['c'][4];
}
//---END---Köməkçi funksiyalar
?>