<?php 





ini_set('display_errors', true);

class createexcel

{    

    //---BEGIN---FORMALAR---

    //Gündəlik qayda pozuntuları üçün forma

    public function runprosesscreatexcel($tableExcel,$fromdate,$todate){

        include ('Classes/PHPExcel.php');

        $yesterdayFromonlydate = date('Y-m-d',strtotime($fromdate));

        $yesterdayToonlydate = date('Y-m-d',strtotime($todate)); 





        $objPHPExcel = new PHPExcel();

        $objPHPExcel->getProperties()->setCreator("Nijat Talibov")

                            ->setLastModifiedBy("Nijat Talibov")

                            ->setTitle("PHPExcel Test Document")

                            ->setSubject("PHPExcel Test Document")

                            ->setDescription("Test document for PHPExcel, generated using PHP classes.")

                            ->setKeywords("office PHPExcel php")

                            ->setCategory("Test result file");



        // $objPHPExcel->createSheet();

        $objPHPExcel->setActiveSheetIndex(0);

        $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A1:G1');

        $objPHPExcel->getActiveSheet()->getStyle('A1:G1')->getAlignment()->setWrapText(true);

        $objPHPExcel->getActiveSheet()->getStyle('A1:G1')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A1:G1')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', 'DAILY FATIGUE REPORT-'.$tableExcel[0]['violation_date']);      

        $objPHPExcel->getActiveSheet()->getStyle("A1")->getFont()->setSize(16);



        $objPHPExcel->getActiveSheet()->getStyle('A1:G2')->getFont()->setBold(true);

        $objPHPExcel->getActiveSheet()->getStyle('A2:G2')->getAlignment()->setWrapText(true);

        $objPHPExcel->getActiveSheet()->getStyle('A2:G2')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A2:G2')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A2:G2')->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'344D5A')));

        $objPHPExcel->getActiveSheet()->getStyle('A2:G2')

                                   ->getBorders()

                                   ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);

        $objPHPExcel->getActiveSheet()

                    ->setCellValue('A2', '№')

                    ->setCellValue('B2', 'Plate')

                    ->setCellValue('C2', 'Max Continues Driving')

                    ->setCellValue('D2', 'Min Break After Continues Driving')

                    ->setCellValue('E2', 'Max Driving Hours in 24 Hour Cycle')

                    ->setCellValue('F2', 'Minimum continues rest period in 24 hour Cycle')

                    ->setCellValue('G2', 'Max on Duty Hours in 24 Hour Cycle');



        $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth('5');

        $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setWidth('35');

        $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getRowDimension(2)->setRowHeight('60');

        $objPHPExcel->getActiveSheet()->getRowDimension(1)->setRowHeight('30');





        $objPHPExcel->getActiveSheet()->getStyle('A')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('B')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('C')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('D')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('E')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('F')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('G')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

   

        if(!empty($tableExcel)){

            $counter=2;

            $number=0;

            foreach ($tableExcel as $key => $value) {

                $counter++;

                $number++;

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("A".($counter),$number);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("B".($counter),$value['driver']);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("C".($counter),$value['cont_driving_count']);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("D".($counter),$value['min_break_after_cont_driving_count']);

                if($value['max_driving']!="00:00:00"){

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("E".($counter),1);

                }

                else{

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("E".($counter),0);

                }

                if($value['min_cont_rest_period']!="00:00:00"){

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("F".($counter),1);

                }

                else{

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("F".($counter),0);

                }

                if($value['max_duty']!="00:00:00"){

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("G".($counter),1);

                }

                else{

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("G".($counter),0);

                }



                $objPHPExcel->getActiveSheet()->getStyle('A'.($counter).':'.'G'.($counter))

                                       ->getBorders()

                                       ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN)

                                       ->getColor()

                                       ->setRGB('000000');

                $objPHPExcel->getActiveSheet()->getStyle('A'.($counter).':'.'G'.($counter))->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'A6A6A6')));    

            }

        }

        
        //---BEGIN---Details---
        $detailsdatas=$this->getdetaildailyviolations($fromdate,$todate);

        //2-ci səhifəni düzəldək
        $sheettwo = $objPHPExcel->createSheet();
        $sheettwo->setTitle("Details");

        $sheettwo->mergeCells('A1:G1');
        $sheettwo->getStyle('A1:G1')->getAlignment()->setWrapText(true);

        $sheettwo->getStyle('A1:G1')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $sheettwo->getStyle('A1:G1')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $sheettwo->setCellValue('A1', 'DETAILS DAILY FATIGUE REPORT-'.$detailsdatas[0]['violation_date']);      

        $sheettwo->getStyle("A1")->getFont()->setSize(16);



        $sheettwo->getStyle('A1:G2')->getFont()->setBold(true);

        $sheettwo->getStyle('A2:G2')->getAlignment()->setWrapText(true);

        $sheettwo->getStyle('A2:G2')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $sheettwo->getStyle('A2:G2')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $sheettwo->getStyle('A2:G2')->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'344D5A')));

        $sheettwo->getStyle('A2:G2')

                                   ->getBorders()

                                   ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);

        $sheettwo

                    ->setCellValue('A2', '№')

                    ->setCellValue('B2', 'Plate')

                    ->setCellValue('C2', 'Date')

                    ->setCellValue('D2', 'Begin')

                    ->setCellValue('E2', 'End')

                    ->setCellValue('F2', 'Delta')

                    ->setCellValue('G2', 'Violation type');



        $sheettwo->getColumnDimension('A')->setWidth('5');

        $sheettwo->getColumnDimension('B')->setWidth('35');

        $sheettwo->getColumnDimension('C')->setWidth('15');

        $sheettwo->getColumnDimension('D')->setWidth('15');

        $sheettwo->getColumnDimension('E')->setWidth('15');

        $sheettwo->getColumnDimension('F')->setWidth('15');

        $sheettwo->getColumnDimension('G')->setWidth('50');

        $sheettwo->getRowDimension(2)->setRowHeight('60');

        $sheettwo->getRowDimension(1)->setRowHeight('30');





        $sheettwo->getStyle('A')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $sheettwo->getStyle('B')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $sheettwo->getStyle('C')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $sheettwo->getStyle('D')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $sheettwo->getStyle('E')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $sheettwo->getStyle('F')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $sheettwo->getStyle('G')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        if(!empty($detailsdatas)){

            $counter=2;

            $number=0;

            foreach ($detailsdatas as $key => $value) {

                $counter++;

                $number++;

                $sheettwo->setCellValue("A".($counter),$number);

                $sheettwo->setCellValue("B".($counter),$value['driver']);

                $sheettwo->setCellValue("C".($counter),$value['violation_date']);


                if($value['begin']!="00:00:00"){

                    $sheettwo->setCellValue("D".($counter),$value['begin']);

                }

                else{

                    $sheettwo->setCellValue("D".($counter),"");

                }

               if($value['end']!="00:00:00"){

                    $sheettwo->setCellValue("E".($counter),$value['end']);

                }

                else{

                    $sheettwo->setCellValue("E".($counter),"");

                }


                $sheettwo->setCellValue("F".($counter),$value['delta']);
                $sheettwo->setCellValue("G".($counter),$value['violation_type']);



                $sheettwo->getStyle('A'.($counter).':'.'G'.($counter))

                                       ->getBorders()

                                       ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN)

                                       ->getColor()

                                       ->setRGB('000000');

                $sheettwo->getStyle('A'.($counter).':'.'G'.($counter))->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'A6A6A6')));    

            }

        }

        //---END---Details---




        $fileName = '/home/aasfle5/holcim.fatigue.aplusa-security.com/holcim/excel/' . 'DAILY FATIGUE-(' .$yesterdayFromonlydate.' - '.$yesterdayToonlydate. ')-DAILY FATIGUE-'.time(). '.xlsx';

        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007'); 

        $objWriter->save($fileName);





        return $fileName;

    }





    //Həhtəlik qayda pozuntuları üçün forma

    public function runweeklyprosesscreatexcel($tableExcel,$fromdate,$todate){

        include ('Classes/PHPExcel.php');

        $lastweekbegin = date('Y-m-d',strtotime($fromdate));

        $lastweekend = date('Y-m-d',strtotime($todate)); 



        $objPHPExcel = new PHPExcel();

        $objPHPExcel->getProperties()->setCreator("Nijat Talibov")

                            ->setLastModifiedBy("Nijat Talibov")

                            ->setTitle("PHPExcel Test Document")

                            ->setSubject("PHPExcel Test Document")

                            ->setDescription("Test document for PHPExcel, generated using PHP classes.")

                            ->setKeywords("office PHPExcel php")

                            ->setCategory("Test result file");



        $objPHPExcel->createSheet();

        $objPHPExcel->setActiveSheetIndex(0);

        $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A1:E1');

        $objPHPExcel->getActiveSheet()->getStyle('A1:E1')->getAlignment()->setWrapText(true);

        $objPHPExcel->getActiveSheet()->getStyle('A1:E1')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A1:E1')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', 'WEEKLY FATIGUE REPORT-'.$lastweekbegin.'-'.$lastweekend);      

        $objPHPExcel->getActiveSheet()->getStyle("A1")->getFont()->setSize(16);



        $objPHPExcel->getActiveSheet()->getStyle('A1:E2')->getFont()->setBold(true);

        $objPHPExcel->getActiveSheet()->getStyle('A2:E2')->getAlignment()->setWrapText(true);

        $objPHPExcel->getActiveSheet()->getStyle('A2:E2')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A2:E2')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A2:E2')->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'344D5A')));

        $objPHPExcel->getActiveSheet()->getStyle('A2:E2')

                                   ->getBorders()

                                   ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);

        $objPHPExcel->getActiveSheet()

                    ->setCellValue('A2', '№')

                    ->setCellValue('B2', 'Plate')

                    ->setCellValue('C2', 'Min consecutive “not driving” break in rolling 7 day period')

                    ->setCellValue('D2', 'Week Begin')

                    ->setCellValue('E2', 'Week End');

        $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth('5');

        $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setWidth('35');

        $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setWidth('28');

        $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getRowDimension(2)->setRowHeight('60');

        $objPHPExcel->getActiveSheet()->getRowDimension(1)->setRowHeight('30');



        $objPHPExcel->getActiveSheet()->getStyle('A')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('B')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('C')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('D')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('E')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

       

   

        if(!empty($tableExcel)){

            $counter=2;

            $number=0;

            foreach ($tableExcel as $key => $value) {

                $counter++;

                $number++;

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("A".($counter),$number);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("B".($counter),$value['driver']);

                if($value['min_notdriving_break_inweek']>0){

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("C".($counter),1);

                }

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("D".($counter),date('Y-m-d',strtotime($value['week_begin'])));

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("E".($counter),date('Y-m-d',strtotime($value['week_end'])));    

                $objPHPExcel->getActiveSheet()->getStyle('A'.($counter).':'.'E'.($counter))

                                       ->getBorders()

                                       ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN)

                                       ->getColor()

                                       ->setRGB('000000');

                $objPHPExcel->getActiveSheet()->getStyle('A'.($counter).':'.'E'.($counter))->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'A6A6A6')));    

            }

        }

        

        $fileName = '/home/aasfle5/holcim.fatigue.aplusa-security.com/holcim/excel/' . 'WEEKLY FATIGUE-(' .$lastweekbegin.' - '.$lastweekend. ')-WEEKLY FATIGUE-'.time(). '.xlsx';

        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');

       

        $objWriter->save($fileName);



        return $fileName;

    }





    //Istənilən zaman qayda pozuntuları üçün forma (Gündəliklərə əsasən)

    public function runanytimeprosesscreatexcel($tableExcel,$fromdate,$todate,$unitsofselectedgroup){

        include ('Classes/PHPExcel.php');

        // $yesterdayFromonlydate = date('Y-m-d',strtotime($fromdate));

        // $yesterdayToonlydate = date('Y-m-d',strtotime($todate)); 

        // print_r('<pre>');
        // print_r($tableExcel);
        // print_r('</pre>');
        // die();

        $objPHPExcel = new PHPExcel();

        $objPHPExcel->getProperties()->setCreator("Nijat Talibov")

                            ->setLastModifiedBy("Nijat Talibov")

                            ->setTitle("PHPExcel Test Document")

                            ->setSubject("PHPExcel Test Document")

                            ->setDescription("Test document for PHPExcel, generated using PHP classes.")

                            ->setKeywords("office PHPExcel php")

                            ->setCategory("Test result file");



        // $objPHPExcel->createSheet();

        $objPHPExcel->setActiveSheetIndex(0);

        $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A1:G1');

        $objPHPExcel->getActiveSheet()->getStyle('A1:G1')->getAlignment()->setWrapText(true);

        $objPHPExcel->getActiveSheet()->getStyle('A1:G1')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A1:G1')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', 'ANYTIME DAILY FATIGUE REPORT-'.$fromdate.'-'.$todate);      

        $objPHPExcel->getActiveSheet()->getStyle("A1")->getFont()->setSize(16);



        $objPHPExcel->getActiveSheet()->getStyle('A1:G2')->getFont()->setBold(true);

        $objPHPExcel->getActiveSheet()->getStyle('A2:G2')->getAlignment()->setWrapText(true);

        $objPHPExcel->getActiveSheet()->getStyle('A2:G2')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A2:G2')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A2:G2')->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'344D5A')));

        $objPHPExcel->getActiveSheet()->getStyle('A2:G2')

                                   ->getBorders()

                                   ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);

        $objPHPExcel->getActiveSheet()

                    ->setCellValue('A2', '№')

                    ->setCellValue('B2', 'Plate')

                    ->setCellValue('C2', 'Max Continues Driving')

                    ->setCellValue('D2', 'Min Break After Continues Driving')

                    ->setCellValue('E2', 'Max Driving Hours in 24 Hour Cycle')

                    ->setCellValue('F2', 'Minimum continues rest period in 24 hour Cycle')

                    ->setCellValue('G2', 'Max on Duty Hours in 24 Hour Cycle');

        $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth('5');

        $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setWidth('35');

        $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getRowDimension(2)->setRowHeight('60');

        $objPHPExcel->getActiveSheet()->getRowDimension(1)->setRowHeight('30');





        $objPHPExcel->getActiveSheet()->getStyle('A')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('B')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('C')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('D')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('E')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('F')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('G')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

   

        if(!empty($tableExcel)){



            $counter=2;

            $number=0;

            foreach ($tableExcel as $key => $value) {

                $counter++;

                $number++;

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("A".($counter),$number);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("B".($counter),$value['driver']);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("C".($counter),$value['cont_driving_count']);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("D".($counter),$value['min_break_after_cont_driving_count']);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("E".($counter),$value['max_driving_count']);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("F".($counter),$value['min_cont_rest_period_count']);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("G".($counter),$value['max_duty_count']);    

                $objPHPExcel->getActiveSheet()->getStyle('A'.($counter).':'.'G'.($counter))

                                       ->getBorders()

                                       ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN)

                                       ->getColor()

                                       ->setRGB('000000');

                $objPHPExcel->getActiveSheet()->getStyle('A'.($counter).':'.'G'.($counter))->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'A6A6A6')));    

            }

        }

        
         //---BEGIN---Details---
        $detailsdatas=$this->getdetaildailyviolations($fromdate,$todate,$unitsofselectedgroup);

        //2-ci səhifəni düzəldək
        $sheettwo = $objPHPExcel->createSheet();
        $sheettwo->setTitle("Details");

        $sheettwo->mergeCells('A1:G1');
        $sheettwo->getStyle('A1:G1')->getAlignment()->setWrapText(true);

        $sheettwo->getStyle('A1:G1')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $sheettwo->getStyle('A1:G1')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $sheettwo->setCellValue('A1', 'DETAILS DAILY FATIGUE REPORT-'.$fromdate.'-'.$todate);      

        $sheettwo->getStyle("A1")->getFont()->setSize(16);



        $sheettwo->getStyle('A1:G2')->getFont()->setBold(true);

        $sheettwo->getStyle('A2:G2')->getAlignment()->setWrapText(true);

        $sheettwo->getStyle('A2:G2')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $sheettwo->getStyle('A2:G2')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $sheettwo->getStyle('A2:G2')->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'344D5A')));

        $sheettwo->getStyle('A2:G2')

                                   ->getBorders()

                                   ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);

        $sheettwo

                    ->setCellValue('A2', '№')

                    ->setCellValue('B2', 'Plate')

                    ->setCellValue('C2', 'Date')

                    ->setCellValue('D2', 'Begin')

                    ->setCellValue('E2', 'End')

                    ->setCellValue('F2', 'Delta')

                    ->setCellValue('G2', 'Violation type');



        $sheettwo->getColumnDimension('A')->setWidth('5');

        $sheettwo->getColumnDimension('B')->setWidth('35');

        $sheettwo->getColumnDimension('C')->setWidth('15');

        $sheettwo->getColumnDimension('D')->setWidth('15');

        $sheettwo->getColumnDimension('E')->setWidth('15');

        $sheettwo->getColumnDimension('F')->setWidth('15');

        $sheettwo->getColumnDimension('G')->setWidth('50');

        $sheettwo->getRowDimension(2)->setRowHeight('60');

        $sheettwo->getRowDimension(1)->setRowHeight('30');





        $sheettwo->getStyle('A')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $sheettwo->getStyle('B')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $sheettwo->getStyle('C')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $sheettwo->getStyle('D')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $sheettwo->getStyle('E')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $sheettwo->getStyle('F')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $sheettwo->getStyle('G')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        if(!empty($detailsdatas)){

            $counter=2;

            $number=0;

            foreach ($detailsdatas as $key => $value) {

                $counter++;

                $number++;

                $sheettwo->setCellValue("A".($counter),$number);

                $sheettwo->setCellValue("B".($counter),$value['driver']);

                $sheettwo->setCellValue("C".($counter),$value['violation_date']);


                if($value['begin']!="00:00:00"){

                    $sheettwo->setCellValue("D".($counter),$value['begin']);

                }

                else{

                    $sheettwo->setCellValue("D".($counter),"");

                }

               if($value['end']!="00:00:00"){

                    $sheettwo->setCellValue("E".($counter),$value['end']);

                }

                else{

                    $sheettwo->setCellValue("E".($counter),"");

                }


                $sheettwo->setCellValue("F".($counter),$value['delta']);
                $sheettwo->setCellValue("G".($counter),$value['violation_type']);



                $sheettwo->getStyle('A'.($counter).':'.'G'.($counter))

                                       ->getBorders()

                                       ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN)

                                       ->getColor()

                                       ->setRGB('000000');

                $sheettwo->getStyle('A'.($counter).':'.'G'.($counter))->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'A6A6A6')));    

            }

        }

        //---END---Details---



        $fileName = '/home/aasfle5/holcim.fatigue.aplusa-security.com/holcim/excel/' . 'ANYTIME DAILY FATIGUE-(' .$fromdate.' - '.$todate. ')-ANYTIME DAILY FATIGUE-'.time(). '.xlsx';

        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');

       

        $objWriter->save($fileName);



        return $fileName;

    }





    //Istənilən zaman qayda pozuntuları üçün forma (Həftəliklərə əsasən)

    public function runanytimeweeklyprosesscreatexcel($tableExcel,$fromdate,$todate){

        include ('Classes/PHPExcel.php');

        // $lastweekbegin = date('Y-m-d',strtotime($fromdate));

        // $lastweekend = date('Y-m-d',strtotime($todate)); 



        $objPHPExcel = new PHPExcel();

        $objPHPExcel->getProperties()->setCreator("Nijat Talibov")

                            ->setLastModifiedBy("Nijat Talibov")

                            ->setTitle("PHPExcel Test Document")

                            ->setSubject("PHPExcel Test Document")

                            ->setDescription("Test document for PHPExcel, generated using PHP classes.")

                            ->setKeywords("office PHPExcel php")

                            ->setCategory("Test result file");



        $objPHPExcel->createSheet();

        $objPHPExcel->setActiveSheetIndex(0);

        $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A1:E1');

        $objPHPExcel->getActiveSheet()->getStyle('A1:E1')->getAlignment()->setWrapText(true);

        $objPHPExcel->getActiveSheet()->getStyle('A1:E1')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A1:E1')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', 'ANYTIME WEEKLY FATIGUE REPORT-'.$fromdate.'-'.$todate);      

        $objPHPExcel->getActiveSheet()->getStyle("A1")->getFont()->setSize(16);



        $objPHPExcel->getActiveSheet()->getStyle('A1:E2')->getFont()->setBold(true);

        $objPHPExcel->getActiveSheet()->getStyle('A2:E2')->getAlignment()->setWrapText(true);

        $objPHPExcel->getActiveSheet()->getStyle('A2:E2')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A2:E2')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A2:E2')->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'344D5A')));

        $objPHPExcel->getActiveSheet()->getStyle('A2:E2')

                                   ->getBorders()

                                   ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);

        $objPHPExcel->getActiveSheet()

                    ->setCellValue('A2', '№')

                    ->setCellValue('B2', 'Plate')

                    ->setCellValue('C2', 'Min consecutive “not driving” break in rolling 7 day period')

                    ->setCellValue('D2', 'Week Begin')

                    ->setCellValue('E2', 'Week End');

        $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth('5');

        $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setWidth('35');

        $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setWidth('28');

        $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getRowDimension(2)->setRowHeight('60');

        $objPHPExcel->getActiveSheet()->getRowDimension(1)->setRowHeight('30');



        $objPHPExcel->getActiveSheet()->getStyle('A')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('B')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('C')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('D')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('E')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

       

   

        if(!empty($tableExcel)){

            $counter=2;

            $number=0;

            foreach ($tableExcel as $key => $value) {

                $counter++;

                $number++;

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("A".($counter),$number);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("B".($counter),$value['driver']);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("C".($counter),$value['min_notdriving_break_inweek_count']);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("D".($counter),$fromdate);

                $objPHPExcel->setActiveSheetIndex(0)->setCellValue("E".($counter),$todate);    

                $objPHPExcel->getActiveSheet()->getStyle('A'.($counter).':'.'E'.($counter))

                                       ->getBorders()

                                       ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN)

                                       ->getColor()

                                       ->setRGB('000000');

                $objPHPExcel->getActiveSheet()->getStyle('A'.($counter).':'.'E'.($counter))->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'A6A6A6')));    

            }

        }

        

        $fileName = '/home/aasfle5/holcim.fatigue.aplusa-security.com/holcim/excel/' . 'ANYTIME WEEKLY FATIGUE-(' .$fromdate.' - '.$todate. ')-ANYTIME WEEKLY FATIGUE-'.time(). '.xlsx';

        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');

       

        $objWriter->save($fileName);



        return $fileName;

    }




     //Istənilən zaman ROAD LIMIT qayda pozuntuları üçün forma

    public function runroadlimitviolationsreportcreatexcel($fromdate,$todate,$tableExcel){

        include ('Classes/PHPExcel.php');

        $objPHPExcel = new PHPExcel();

        $objPHPExcel->getProperties()->setCreator("Nijat Talibov")

                            ->setLastModifiedBy("Nijat Talibov")

                            ->setTitle("PHPExcel Test Document")

                            ->setSubject("PHPExcel Test Document")

                            ->setDescription("Test document for PHPExcel, generated using PHP classes.")

                            ->setKeywords("office PHPExcel php")

                            ->setCategory("Test result file");



        // $objPHPExcel->createSheet();

        $objPHPExcel->setActiveSheetIndex(0);

        $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A1:H1');

        $objPHPExcel->getActiveSheet()->getStyle('A1:H1')->getAlignment()->setWrapText(true);

        $objPHPExcel->getActiveSheet()->getStyle('A1:H1')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A1:H1')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', 'ROAD LIMIT VIOLATIONS REPORT-'.$fromdate.'-'.$todate);      

        $objPHPExcel->getActiveSheet()->getStyle("A1")->getFont()->setSize(16);



        $objPHPExcel->getActiveSheet()->getStyle('A1:H2')->getFont()->setBold(true);

        $objPHPExcel->getActiveSheet()->getStyle('A2:H2')->getAlignment()->setWrapText(true);

        $objPHPExcel->getActiveSheet()->getStyle('A2:H2')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A2:H2')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A2:H2')->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'344D5A')));

        $objPHPExcel->getActiveSheet()->getStyle('A2:H2')

                                   ->getBorders()

                                   ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);

        $objPHPExcel->getActiveSheet()

                    ->setCellValue('A2', '№')

                    ->setCellValue('B2', 'Plate')

                    ->setCellValue('C2', 'Start Time')

                    ->setCellValue('D2', 'End Time')

                    ->setCellValue('E2', 'Duration (sec)')

                    ->setCellValue('F2', 'Speed Limit (km/h)')

                    ->setCellValue('G2', 'Max Speed (km/h)')

                    ->setCellValue('H2', 'Location');

        $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth('5');

        $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setWidth('35');

        $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setWidth('25');

        $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setWidth('25');

        $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('H')->setWidth('35');

        $objPHPExcel->getActiveSheet()->getRowDimension(2)->setRowHeight('60');

        $objPHPExcel->getActiveSheet()->getRowDimension(1)->setRowHeight('30');





        $objPHPExcel->getActiveSheet()->getStyle('A')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('B')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('C')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('D')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('E')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('F')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('G')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('H')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

   

        if(!empty($tableExcel)){



            $counter=2;

            $number=0;

            foreach ($tableExcel as $groupkey => $groupvalue) {
                foreach ($groupvalue as $key => $value) {
                    $counter++;

                    $number++;

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("A".($counter),$number);

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("B".($counter),$groupkey);

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("C".($counter),$value['timestamp_start']);

                    //End Time 1 saniyə əlavə edək
                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("D".($counter),date('Y-m-d H:i:s',strtotime($value['timestamp_end']) + 1));

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("E".($counter),$value['duration']);

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("F".($counter),$value['speed_limit_custom']);

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("G".($counter),$value['max_speed']); 

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("H".($counter),$value['street_name_osm'])->getHyperlink("H".($counter))->setUrl("https://www.google.com/maps/place/".$this->DMStoDD($value['latitude'])."N+".$this->DMStoDD($value['longitude'])."E/@".$value['latitude'].",".$value['longitude'].",17z/data=!3m1!4b1!4m5!3m4!1s0x0:0x0!8m2!3d".$value['latitude']."!4d".$value['longitude']);

                    $objPHPExcel->getActiveSheet()->getStyle('A'.($counter).':'.'H'.($counter))

                                           ->getBorders()

                                           ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN)

                                           ->getColor()

                                           ->setRGB('000000');

                    $objPHPExcel->getActiveSheet()->getStyle('A'.($counter).':'.'H'.($counter))->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'A6A6A6')));    
                }
            }

        }


        $fileName = '/home/aasfle5/holcim.fatigue.aplusa-security.com/holcim/excel/' . 'ROAD LIMIT VIOLATIONS REPORT-(' .$fromdate.' - '.$todate. ')-ROAD LIMIT VIOLATIONS REPORT-'.time(). '.xlsx';
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
        $objWriter->save($fileName);
        return $fileName;

    }


     //Istənilən zaman DELIVERY REPORT by IMPORTED EXCEL üçün forma

    public function runcomparewialonandvisitedimportexcelscreatexcel($fromdate,$todate,$tableExcel){

        include ('Classes/PHPExcel.php');

        $objPHPExcel = new PHPExcel();

        $objPHPExcel->getProperties()->setCreator("Nijat Talibov")

                            ->setLastModifiedBy("Nijat Talibov")

                            ->setTitle("PHPExcel Test Document")

                            ->setSubject("PHPExcel Test Document")

                            ->setDescription("Test document for PHPExcel, generated using PHP classes.")

                            ->setKeywords("office PHPExcel php")

                            ->setCategory("Test result file");



        // $objPHPExcel->createSheet();

        $objPHPExcel->setActiveSheetIndex(0);

        $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A1:L1');

        $objPHPExcel->getActiveSheet()->getStyle('A1:L1')->getAlignment()->setWrapText(true);

        $objPHPExcel->getActiveSheet()->getStyle('A1:L1')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A1:L1')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', 'DELIVERY REPORT BY IMPORTED EXCEL-'.$fromdate.'-'.$todate);      

        $objPHPExcel->getActiveSheet()->getStyle("A1")->getFont()->setSize(16);



        $objPHPExcel->getActiveSheet()->getStyle('A1:L2')->getFont()->setBold(true);

        $objPHPExcel->getActiveSheet()->getStyle('A2:L2')->getAlignment()->setWrapText(true);

        $objPHPExcel->getActiveSheet()->getStyle('A2:L2')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A2:L2')->getAlignment()->setVertical(PHPExcel_Style_Alignment::VERTICAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('A2:L2')->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'344D5A')));

        $objPHPExcel->getActiveSheet()->getStyle('A2:L2')

                                   ->getBorders()

                                   ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN);

        $objPHPExcel->getActiveSheet()

                    ->setCellValue('A2', '№')

                    ->setCellValue('B2', 'LOADING_TS')

                    ->setCellValue('C2', 'ORDER_NUMBER')

                    ->setCellValue('D2', 'LDS_DELIVERY_NOTE_NO')

                    ->setCellValue('E2', 'SHIPTO_SAP_NO')

                    ->setCellValue('F2', 'SOLDTO')

                    ->setCellValue('G2', 'CITY')

                    ->setCellValue('H2', 'SHIPTO')

                    ->setCellValue('I2', 'VEHICLE')
                    ->setCellValue('J2', 'VISIT')
                    ->setCellValue('K2', 'IDLE')
                    ->setCellValue('L2', 'COMPRESSOR');

        $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth('5');

        $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setWidth('25');

        $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setWidth('20');

        $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setWidth('25');

        $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setWidth('35');

        $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setWidth('15');

        $objPHPExcel->getActiveSheet()->getColumnDimension('H')->setWidth('35');
        $objPHPExcel->getActiveSheet()->getColumnDimension('I')->setWidth('25');
        $objPHPExcel->getActiveSheet()->getColumnDimension('J')->setWidth('20');
        $objPHPExcel->getActiveSheet()->getColumnDimension('K')->setWidth('20');
        $objPHPExcel->getActiveSheet()->getColumnDimension('L')->setWidth('20');

        $objPHPExcel->getActiveSheet()->getRowDimension(2)->setRowHeight('60');

        $objPHPExcel->getActiveSheet()->getRowDimension(1)->setRowHeight('30');





        $objPHPExcel->getActiveSheet()->getStyle('A')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('B')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_LEFT);

        $objPHPExcel->getActiveSheet()->getStyle('C')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('D')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('E')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('F')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('G')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);

        $objPHPExcel->getActiveSheet()->getStyle('H')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objPHPExcel->getActiveSheet()->getStyle('I')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objPHPExcel->getActiveSheet()->getStyle('J')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objPHPExcel->getActiveSheet()->getStyle('K')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
        $objPHPExcel->getActiveSheet()->getStyle('L')->getAlignment()->setHorizontal(PHPExcel_Style_Alignment::HORIZONTAL_CENTER);
   

        if(!empty($tableExcel)){

            $counter=2;

            $number=0;

            foreach ($tableExcel as $value) {
                    $counter++;

                    $number++;

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("A".($counter),$number);

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("B".($counter),$value['loading_ts']);

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("C".($counter),$value['order_number']);

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("D".($counter),$value['lds_delivery_note_no']);

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("E".($counter),$value['shipto_sap_no']);

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("F".($counter),$value['sold_to']);

                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("G".($counter),$value['city']); 
                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("H".($counter),$value['ship_to']); 
                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("I".($counter),$value['vehicle']); 
                    
                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("J".($counter),$value['check_visited_zones']); 
                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("K".($counter),$value['check_idle']); 
                    $objPHPExcel->setActiveSheetIndex(0)->setCellValue("L".($counter),$value['check_compressor']);


                    $objPHPExcel->getActiveSheet()->getStyle('A'.($counter).':'.'L'.($counter))

                                           ->getBorders()

                                           ->getAllBorders()->setBorderStyle(PHPExcel_Style_Border::BORDER_THIN)

                                           ->getColor()

                                           ->setRGB('000000');

                    $objPHPExcel->getActiveSheet()->getStyle('A'.($counter).':'.'L'.($counter))->getFill()->applyFromArray(array('type' => PHPExcel_Style_Fill::FILL_SOLID,'startcolor' => array('rgb' =>'A6A6A6')));    
                }
        }


        $fileName = '/home/aasfle5/holcim.fatigue.aplusa-security.com/holcim/excel/' . 'DELIVERY REPORT BY IMPORTED EXCEL-(' .$fromdate.' - '.$todate. ')-DELIVERY REPORT by IMPORTED EXCEL-'.time(). '.xlsx';
        $objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');
        $objWriter->save($fileName);
        return $fileName;

    }



    // ---END---FORMALAR---







    //---BEGIN-FORMALARI İŞƏ SALAN FUNKSİYALAR---

    //Gündəlik excel formasını işə salaq

    public function rundailyexcel($fromdate,$todate){

        include_once 'database/db.php';

        $dbdailyexcel= new Database("localhost","aasfle5_HolcimFatigueUser","ggUsjQl&Oa.[","aasfle5_HolcimFatigue");

        $yesterdayFromonlydate = date('Y-m-d',strtotime($fromdate));

        $yesterdayToonlydate = date('Y-m-d',strtotime($todate)); 

        $dailyviolationswhere= "violation_date>='".$yesterdayFromonlydate."' and violation_date<='".$yesterdayToonlydate."'";

        $dailyviolationsdatas=$dbdailyexcel->select("DailyViolations",$dailyviolationswhere);

        $tableExcel=$dailyviolationsdatas;



        unset($dbdailyexcel);

        $answer=$this->runprosesscreatexcel($tableExcel,$fromdate,$todate);



        return $answer;

    }





    //Həftəlik excel formasını işə salaq

    public function runweeklyexcel($fromdate,$todate){

        include_once 'database/db.php';

        $dbweeklyexcel= new Database("localhost","aasfle5_HolcimFatigueUser","ggUsjQl&Oa.[","aasfle5_HolcimFatigue");

        $lastweekbegin = date('Y-m-d H:i:s',strtotime($fromdate));

        $lastweekend = date('Y-m-d H:i:s',strtotime($todate)); 

        $weeklyviolationswhere= "week_begin>='".$lastweekbegin."' and week_end<='".$lastweekend."'";

        $weeklyviolationsdatas=$dbweeklyexcel->select("WeeklyViolations",$weeklyviolationswhere);

        $tableExcel=$weeklyviolationsdatas;



        unset($dbweeklyexcel);

        $answer=$this->runweeklyprosesscreatexcel($tableExcel,$fromdate,$todate);



        return $answer;

    }





    //Istənilən tarix üçün excel formasını işə salaq (Gündəliklərə əsasən)

    public function runanytimeexcel($fromdate,$todate,$unitsofselectedgroup){

        include 'database/db.php';

        $dbanytimeexcel= new Database("localhost","aasfle5_HolcimFatigueUser","ggUsjQl&Oa.[","aasfle5_HolcimFatigue");

        $anytimeviolationswhere= "violation_date>='".$fromdate."' and violation_date<='".$todate."'";

        $anytimeviolationsdatas=$dbanytimeexcel->select("DailyViolations",$anytimeviolationswhere); 
        $unitwithviolations=array();
        $result=array();
    
        //Əgər qrup seçilibsə bura işləyir,seçilməyibsə bütün maşınlar üçün işləyir
        if($unitsofselectedgroup!=null){
            foreach($unitsofselectedgroup[1] as $unitid){
                foreach($anytimeviolationsdatas as $violation){
                    if($unitid==$violation['drivercode']){
                        array_push($unitwithviolations, $violation);
                    }
                }
            }
            $result=$unitwithviolations;
        }else{
            $result=$anytimeviolationsdatas;
        }

        

        $tableExcel=array();

        if(!empty($result)){

            //Sürücünün adına görə qruplaşdıraq

            $groupbydriver = array();

            foreach ( $result as $value ) {

                if (isset($value['drivercode'])) {

                    if($value['drivercode']!=null){

                        $groupbydriver[$value['drivercode']][] = $value;

                    }  

                }

            }

           

            //Eyni adlı Sürücülərin nəticələrini toplayaq

            foreach ( $groupbydriver as $driveritem ) {

                $tableExcelItem=array();

                $Vcont_driving_time_count=0;

                $Vcont_driving_time=0;

                $Vmin_break_after_cont_driving_count=0;

                $Vmin_break_after_cont_driving_time=0;

                $Vmax_driving_count=0;

                $Vmax_driving_time=0;

                $Vmin_cont_rest_period_count=0;

                $Vmin_cont_rest_period_time=0;

                $Vmax_duty_count=0;

                $Vmax_duty_time=0;



                foreach ( $driveritem as $item ) {

                    $Vcont_driving_time_count+=$item['cont_driving_count'];

                    $Vcont_driving_time+=$this->explode_time($item['cont_driving_time']);

                    $Vmin_break_after_cont_driving_count+=$item['min_break_after_cont_driving_count'];

                    $Vmin_break_after_cont_driving_time+=$this->explode_time($item['min_break_after_cont_driving_time']);

                    if($item['max_driving']!="00:00:00"){

                        $Vmax_driving_count++;

                        $Vmax_driving_time+=$this->explode_time($item['max_driving']);

                    }

                    if($item['min_cont_rest_period']!="00:00:00"){

                        $Vmin_cont_rest_period_count++;

                        $Vmin_cont_rest_period_time+=$this->explode_time($item['min_cont_rest_period']);

                    }

                    if($item['max_duty']!="00:00:00"){

                        $Vmax_duty_count++;

                        $Vmax_duty_time+=$this->explode_time($item['max_duty']);

                    }

                

                }



                $tableExcelItem['driver']=$item['driver'];

                $tableExcelItem['cont_driving_count']= $Vcont_driving_time_count;

                $tableExcelItem['cont_driving_time']=$this->second_to_hhmm($Vcont_driving_time);

                $tableExcelItem['min_break_after_cont_driving_count']=$Vmin_break_after_cont_driving_count;

                $tableExcelItem['min_break_after_cont_driving_time']=$this->second_to_hhmm($Vmin_break_after_cont_driving_time);

                $tableExcelItem['max_driving_count']=$Vmax_driving_count;

                $tableExcelItem['max_driving_time']= $this->second_to_hhmm($Vmax_driving_time);

                $tableExcelItem['min_cont_rest_period_count']=$Vmin_cont_rest_period_count;

                $tableExcelItem['min_cont_rest_period_time']= $this->second_to_hhmm($Vmin_cont_rest_period_time);

                $tableExcelItem['max_duty_count']= $Vmax_duty_count;

                $tableExcelItem['max_duty_time']= $this->second_to_hhmm($Vmax_duty_time);



                array_push($tableExcel, $tableExcelItem);



                $tableExcelItem=[];

                $Vcont_driving_time_count=0;

                $Vcont_driving_time=0;

                $Vmin_break_after_cont_driving_time_count=0;

                $Vmin_break_after_cont_driving_time=0;

                $Vmax_driving_count=0;

                $Vmax_driving_time=0;

                $Vmin_cont_rest_period_count=0;

                $Vmin_cont_rest_period_time=0;

                $Vmax_duty_count=0;

                $Vmax_duty_time=0;

            }

        }

        unset($dbanytimeexcel);

        $answer=$this->runanytimeprosesscreatexcel($tableExcel,$fromdate,$todate,$unitsofselectedgroup);



        return $answer;       

    }





    //Istənilən tarix üçün excel formasını işə salaq (Həftəliklərə əsasən)

    public function runanytimeweeklyexcel($fromdate,$todate,$unitsofselectedgroup){

        include_once 'database/db.php';

        $dbanytimeweeklyexcel= new Database("localhost","aasfle5_HolcimFatigueUser","ggUsjQl&Oa.[","aasfle5_HolcimFatigue");

        $anytimeweeklyviolationswhere= "week_begin>='".$fromdate."' and week_end<='".$todate."'";

        $anytimeweeklyviolationsdatas=$dbanytimeweeklyexcel->select("WeeklyViolations",$anytimeweeklyviolationswhere);

        $unitwithviolations=array();

 
        foreach($unitsofselectedgroup[1] as $unitid){
            foreach($anytimeweeklyviolationsdatas as $violation){
                if($unitid==$violation['drivercode']){
                    array_push($unitwithviolations, $violation);
                }
            }
        }
        $result=$unitwithviolations;

        $tableExcel=array();

        if(!empty($result)){

            //Sürücünün adına görə qruplaşdıraq

            $groupbydriver = array();

            foreach ( $result as $value ) {

                if (isset($value['drivercode'])) {

                    if($value['drivercode']!=null){

                        $groupbydriver[$value['drivercode']][] = $value;

                    }  

                }

            }

           

            //Eyni adlı Sürücülərin nəticələrini toplayaq

            foreach ( $groupbydriver as $driveritem ) {

                $tableExcelItem=array();

                $Vmin_notdriving_break_inweek_double=0;

                $Vmin_notdriving_break_inweek_count=0;

                

                foreach ( $driveritem as $item ) {

                    $Vmin_notdriving_break_inweek_double+=$item['min_notdriving_break_inweek'];

                    $Vmin_notdriving_break_inweek_count++;          

                }



                $tableExcelItem['driver']=$item['driver'];

                $tableExcelItem['min_notdriving_break_inweek']= $Vmin_notdriving_break_inweek_double;

                $tableExcelItem['min_notdriving_break_inweek_count']= $Vmin_notdriving_break_inweek_count;

                $tableExcelItem['week_begin']=$item['week_begin'];

                $tableExcelItem['week_end']=$item['week_end'];





                array_push($tableExcel, $tableExcelItem);



                $tableExcelItem=[];

                $Vmin_notdriving_break_inweek_count=0;

                $Vmin_notdriving_break_inweek_double=0;

            }

        }

        unset($dbanytimeweeklyexcel);

        $answer=$this->runanytimeweeklyprosesscreatexcel($tableExcel,$fromdate,$todate);



        return $answer;       



    }



    //Gündəlik ətraflı məlumatları əldə edək

    public function getdetaildailyviolations($fromdate,$todate,$unitsofselectedgroup=Null){

        include_once 'database/db.php';

        $dbdetailsdailyexcel= new Database("localhost","aasfle5_HolcimFatigueUser","ggUsjQl&Oa.[","aasfle5_HolcimFatigue");

        $yesterdayFromonlydate = date('Y-m-d',strtotime($fromdate));

        $yesterdayToonlydate = date('Y-m-d',strtotime($todate)); 

        $detaildailyviolationswhere= "violation_date>='".$yesterdayFromonlydate."' and violation_date<='".$yesterdayToonlydate."'";

        $detaildailyviolationsdatas=$dbdetailsdailyexcel->select("DailyViolationDetails",$detaildailyviolationswhere);

        usort($detaildailyviolationsdatas, function($a, $b) {
                return $a['driver'] <=> $b['driver'];
        });

        $unitwithviolations=array();
        $result=array();

        //Əgər qrup seçilibsə bura işləyir,seçilməyibsə bütün maşınlar üçün işləyir
        if($unitsofselectedgroup!=null){
            foreach($unitsofselectedgroup[1] as $unitid){
                foreach($detaildailyviolationsdatas as $violation){
                    if($unitid==$violation['drivercode']){
                        array_push($unitwithviolations, $violation);
                    }
                }
            }
            $result=$unitwithviolations;
        }else{
            $result=$detaildailyviolationsdatas;
        }

        $answer=$result;
        unset($dbdetailsdailyexcel);

        return $answer;

    }



    public function explode_time($time) { //explode time and convert into seconds

        $time = explode(':', $time);

        $time = $time[0] * 3600 + $time[1] * 60+ $time[2];

        return $time;

    }



    public function second_to_hhmm($time) { //convert seconds to hh:mm

        $hour = floor($time / 3600);

        $minute = strval(floor(($time % 3600) / 60));

        $second = $time % 60;

        if ($minute == 0) {

            $minute = "00";

        } else {

            $minute = $minute;

        }



        if ($second == 0) {

            $second = "00";

        } else {

            $second = $second;

        }

        $time = $hour . ":" . $minute . ":" .$second;

        return $time;

    }


    public function DMStoDD($input){
	    $deg = " " ;
	    $min = " " ;
	    $sec = " " ;  
	    $inputM = " " ;        


	    // print "<br> Input is ".$input." <br>";

	    for ($i=0; $i < strlen($input); $i++) 
	    {                     
	        $tempD = $input[$i];
	         //print "<br> TempD [$i] is : $tempD"; 

	        if ($tempD == iconv("UTF-8", "ISO-8859-1//TRANSLIT", '°') ) 
	        { 
	            $newI = $i + 1 ;
	            //print "<br> newI is : $newI"; 
	            $inputM =  substr($input, $newI, -1) ;
	            break; 
	        }//close if degree

	        $deg .= $tempD ;                    
	    }//close for degree

	     //print "InputM is ".$inputM." <br>";

	    for ($j=0; $j < strlen($inputM); $j++) 
	    { 
	        $tempM = $inputM[$j];
	         //print "<br> TempM [$j] is : $tempM"; 

	        if ($tempM == "'")  
	         {                     
	            $newI = $j + 1 ;
	             //print "<br> newI is : $newI"; 
	            $sec =  substr($inputM, $newI, -1) ;
	            break; 
	         }//close if minute
	         $min .= $tempM ;                    
	    }//close for min

	    $result =  $deg+( (( $min*60)+($sec) ) /3600 );
	    // print "<br> Degree is ". $deg*1 ;
	    // print "<br> Minutes is ". $min ;
	    // print "<br> Seconds is ". $sec ;
	    // print "<br> Result is ". $result ;
		return $deg + ($min / 60) + ($sec / 3600);//convert degree to degree minute
	}

    //---END-FORMALARI İŞƏ SALAN FUNKSİYALAR---

}



 ?>