<?php

Class Database {

    private $host;
    private $username;
    private $password;
    private $dbname;
    private $conn;
    private $result=[];

    public function __construct($hostPr, $usernamePr, $passwordPr, $dbnamePr) {
        $this->host = $hostPr;
        $this->username = $usernamePr;
        $this->password = $passwordPr;
        $this->dbname = $dbnamePr;
        $this->connect();
    }

    public function connect() {
        $this->conn = new mysqli($this->host, $this->username, $this->password, $this->dbname);
        if (!$this->conn) { 
            die('Can"t connect Database');
        }
        $this->conn->set_charset('utf8');
    }

    public function disconnect() {
        $this->conn->close();
    }

    public function select($tableName, $where = Null, $orderby = Null, $limit = Null, $offset = 0,$fields = '*') {
        $this->connect();
        $sql = "SELECT $fields FROM $tableName";
        if ($where == !NULL) {
            $sql .= " WHERE $where";

        }

        if ($orderby == !NULL) {
            $sql .= " ORDER BY $orderby";
        }

        if ($limit == !NULL) {
            $sql .= " LIMIT $limit";
        }

        if ($offset != 0) {
            $sql .= " OFFSET $offset";
        }

        $send = $this->conn->query($sql);
        $this->result = array();
        if ($send->num_rows ==0) 
        {
            $this->result = $send->fetch_assoc();
            return $this->result;
        } 
        elseif ($send->num_rows >= 1) 
        {
            while ($row = $send->fetch_assoc()) 
            {
                array_push($this->result, $row);
            }
            return $this->result;

        } 
        else 
        {
           return $this->result = Null;
        }
        $db->disconnect();

        //  print_r("<pre>");
        // print_r($orderby);
        // print_r("</pre>");
        // die();
    }

    public function delete($tableName, $where) {
        $sql = "DELETE FROM `$tableName` WHERE ID =$where";
        
        $result = $this->conn->query($sql);

        if ($result) {
            return TRUE;
        } else {
            return false;
        }
    }

    public function update($tableName, $data, $condition) {
        $sql = "UPDATE `$tableName` SET";

        $i = 1;
        foreach ($data as $key => $value)
        {
            if ($i == count($data)) {
                $sql .= " $key = '$value' ";

            } else {
                $sql .= " $key = '$value' , ";
            }

            $i++;
        }

        $sql .= " WHERE id=$condition";
        // print_r("<pre>");
        // print_r($sql);
        // print_r("</pre>");
        // die();
        $result = $this->conn->query($sql);

        if ($result) {
            return TRUE;
        } else {
            return FALSE;
        }
    }

    public function insert($tableName, $data) {
        $this->connect();
        $sql = "INSERT INTO `$tableName`";
        $sql .="(";
        $keys = array_keys($data);
        foreach ($keys as $key => $value) {
            if ($key == count($keys) - 1) {
                $sql .= '`' . $value . '`';
            } else {
                $sql .= '`' . $value . '` ,';
            }
        }
        $values = array_values($data);
        $sql .=") VALUES (";

        foreach ($values as $key => $value) {
            if ($key == count($values) - 1) {
                $sql .= " '$value' ";
            } else {
                $sql .= " '$value' ,";
            }
        }

        $sql .=")";


        $result = $this->conn->query($sql);



        if ($result) {
            return TRUE;
        } else {
            return FALSE;
        }

    }


    public function insertWithErrorResponse($tableName, $data) {
        $this->connect();
        $sql = "INSERT INTO `$tableName`";
        $sql .="(";
        $keys = array_keys($data);
        foreach ($keys as $key => $value) {
            if ($key == count($keys) - 1) {
                $sql .= '`' . $value . '`';
            } else {
                $sql .= '`' . $value . '` ,';
            }
        }
        $values = array_values($data);
        $sql .=") VALUES (";

        foreach ($values as $key => $value) {
            if ($key == count($values) - 1) {
                $sql .= " '$value' ";
            } else {
                $sql .= " '$value' ,";
            }
        }

        $sql .=")";


        $result = $this->conn->query($sql);

        $response['type']="";
        $response['message'];

        if ($result) {
            $response['type']=true;
            $response['message']="OK";
        } else {
            $response['type']=false;
            $response['message']=$this->conn->error;
        }

        return $response;

    }

    public function deleteMultiple($tableName, $where) {
        $sql = "DELETE FROM `$tableName` WHERE $where";
        
        $result = $this->conn->query($sql);

        if ($result) {
            return TRUE;
        } else {
            return false;
        }
    }

    public function getResult() {
        return $this->result;
    }

}
 
 // $db= new Database("localhost","aasfle5_HolcimFatigueUser","ggUsjQl&Oa.[","aasfle5_HolcimFatigue");

?>