<?php 
ini_set('display_errors', true);
session_start();
include 'wialon.php';
include 'Wialon/wialon.php';
include 'getholcimtoken.php';
include __DIR__ . "/sendMail.php";
require_once 'Classes/PhpSpreadSheet/vendor/autoload.php';
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;
use PhpOffice\PhpSpreadsheet\IOFactory;
use PhpOffice\PhpSpreadsheet\Chart\Chart;

$tokenholcim=new getholcimtoken();
$token=$tokenholcim->gettoken();
$_SESSION['wialon']=new WialonApi($token);
$GLOBALS['unit_all'] = array();
$allUnits=$_SESSION['wialon']->allUnits();
array_push($GLOBALS['unit_all'], $allUnits);

$GLOBALS['fatiguedailyresult']=array();
$GLOBALS['fatigueweeklyresult']=array();

function report()
{
  include 'database/db.php';

  date_default_timezone_set('Asia/Baku');
  $vehicle_group_id= $_POST['vehicle_group'];
  $timeFrom= strtotime($_POST['timeFrom']);
  $timeTo= strtotime($_POST['timeTo']);
  $vehicle_id= $_POST['unit_id'];

  echo $vehicle_id;
  $email=array();
  $unitsANDgroupname=UnitOfGroup($vehicle_group_id);
  $groupname=$unitsANDgroupname[0];
  $units=$unitsANDgroupname[1];

  //---BEGIN---Seçilmiş interval üçün Yorğunluqa aid məlumatları əldə edək
	$anytimebegin = date('Y-m-d',$timeFrom);
	$anytimeend = date('Y-m-d',$timeTo);

  $dbfatigueviolation= new Database("localhost","aasfle5_HolcimFatigueUser","ggUsjQl&Oa.[","aasfle5_HolcimFatigue");

  //Gündəlik qayda pozuntuları
  $anytimeviolationswhere= "violation_date>='".$anytimebegin."' and violation_date<='".$anytimeend."'";
  $fatiguedailyiolationsdatas=$dbfatigueviolation->select("DailyViolations",$anytimeviolationswhere); 
  if(!empty($fatiguedailyiolationsdatas)){
    //Maşının id-nə görə qruplaşdıraq
    $groupbyvehicleiddaily = array();
    foreach ( $fatiguedailyiolationsdatas as $value ) {
        if (isset($value['drivercode'])) {
            if($value['drivercode']!=null){
                $groupbyvehicleiddaily[$value['drivercode']][] = $value;
            }  
        }
    }
    $GLOBALS['fatiguedailyresult']=$groupbyvehicleiddaily;
  }

  //Həftəlik qayda pozuntuları
  $anytimeweeklyviolationswhere= "week_begin>='".$anytimebegin."' and week_end<='".$anytimeend."'";
  $fatigueweeklyiolationsdatas=$dbfatigueviolation->select("WeeklyViolations",$anytimeweeklyviolationswhere);
  if(!empty($fatigueweeklyiolationsdatas)){
    //Maşının id-nə görə qruplaşdıraq
    $groupbyvehicleidweekly = array();
    foreach ( $fatigueweeklyiolationsdatas as $value ) {
        if (isset($value['drivercode'])) {
            if($value['drivercode']!=null){
                $groupbyvehicleidweekly[$value['drivercode']][] = $value;
            }  
        }
    }
    $GLOBALS['fatigueweeklyresult']=$groupbyvehicleidweekly;
  }
  //---END---Seçilmiş interval üçün Yorğunluqa aid məlumatları əldə edək


  $tableExcel=array();
  if ($vehicle_id==0) {
    foreach ($units as $key => $unit_id) 
    {
        $report=getExecReportrag($unit_id,$timeFrom,$timeTo,$groupname);
        array_push($tableExcel, $report);
    }
  }else{
    $report=getExecReportrag($vehicle_id,$timeFrom,$timeTo,$groupname);
    array_push($tableExcel, $report);
  }

  print_r('<pre>');
  print_r($tableExcel);
  print_r('</pre>');
  // die();



  $email[0] = $_POST['email'];
  $keys = array_map(function($val) { return $val['rag_score']; }, $tableExcel);
  array_multisort($keys, $tableExcel);
  writeExcel($tableExcel,$email,$timeFrom,$timeTo);
  echo  1;   
}
  
  // return units 
  function UnitOfGroup($group_id)
  {
    $unit_group=$_SESSION['wialon']->unit_group();
    $unitidANDgroupname=array();
    foreach ($unit_group as $key => $value) 
    {
      if ($value["id"]==$group_id) 
      {   
        // echo "unit count =".count($value['u'])."<br>";
        array_push($unitidANDgroupname, $value['nm']);
        array_push($unitidANDgroupname, $value['u']);
        return $unitidANDgroupname;
      }
    }
  }

  function getExecReportrag($unit_id,$timeFrom="",$timeTo="",$groupname)
  {
    // echo "unit_id=".$unit_id."<br>";
    // $timeFrom = strtotime('01.10.2017 00:00');
    // $timeTo = strtotime('30.10.2017 23:59');
    $timeBegin = time();
    $param = array(
                "reportResourceId"=>14147503,
                "reportTemplateId"=>17,
                "reportObjectId"=>$unit_id,
                "reportObjectSecId"=>0,
                "interval"=>array( 
                "from"=>$timeFrom, //0,
                "to"=>$timeTo, //1,      
                "flags"=>0x00
               )        
            );
    
    $wialon=$_SESSION['wialon']->connect();

              //  for local time format
    $locale_set_params = array(
                      'tzOffset'=>134232128,
                      'language'=>'EN',
                      'flags'=>256,
                      'formatDate'=>'%25E.%25m.%25Y%25H:%25M:%25S'
                      );
    $locale_set_response = $wialon->render_set_locale(json_encode($locale_set_params));

             $attempts = 0; 
             $response =  $wialon->report_exec_report(json_encode($param));
             $response_json = json_decode($response,true);
             $numberOfTables = count($response_json['reportResult']['tables']);
             // echo "reponse=".$response."<br>";
            if ($numberOfTables>=1) 
            {
                 $report=array();
                for ($k=0;$k<$numberOfTables;$k++)
                {
                    $report_param = array(
                        'tableIndex'=>$k,
                        'config'=>array(
                              'type'=>'range',
                              'data'=>array(
                                  'from'=>0,
                                  'to'=>76000,
                                  'level'=>1
                              )
                            )
                     );      

                    $table[$k] = $wialon->report_select_result_rows(json_encode($report_param));
                    $table_json[$k] = json_decode($table[$k],true);
                    
                    array_push($report, $table_json[$k]);

                }
                 $wialon->logout();
                return getReportTempData($report,$unit_id,$groupname);
            } 
               
             $timeEnd = time();
             $execTime = $timeEnd - $timeBegin;
        ob_flush();
        flush();
  }


  function getReportTempData($array,$unit,$groupname)
 {
      include_once 'database/db.php';
      $ragconfig= new Database("localhost","aasfle5_HolcimFatigueUser","ggUsjQl&Oa.[","aasfle5_HolcimFatigue");

      //---BEGIN---Qayda pozuntusunu təyin edən Limitləri Configurations cədvəlindən yükləyək---
      $configwhere="active=1";
      $allconfigurations=$ragconfig->select("Configurations", $configwhere, NuLL ,1);
      $dec_penalty=$allconfigurations[0]['dec_penalty'];
      $acc_penalty=$allconfigurations[0]['acc_penalty'];
      $overspeed_penalty=$allconfigurations[0]['overspeed_penalty'];
      $hos_penalty=$allconfigurations[0]['hos_penalty'];
      //---END---Qayda pozuntusunu təyin edən Limitləri Configurations cədvəlindən yükləyək---

 
      //---BEGIN---Gündəlik qayda pozuntularını toplayaq---
      $sumtotaldailyviol=0;
      foreach ( $GLOBALS['fatiguedailyresult'] as $items ) {
    
        if($items[0]['drivercode']==$unit){
          foreach ( $items as $itemdata ) {
            $cont_driving_time=explode_time($itemdata['cont_driving_time']);
            $max_driving=explode_time($itemdata['max_driving']); 
            $min_cont_rest_period=explode_time($itemdata['min_cont_rest_period']);
            $totaldailyviol= ($cont_driving_time + $max_driving+$min_cont_rest_period)/60;
            $sumtotaldailyviol+=$totaldailyviol;

            print_r('<pre>');
            print_r("********daily melumatlar************");
            print_r('</pre>');
            print_r('<pre>');
            print_r($itemdata['cont_driving_time']);
            print_r('</pre>');
            print_r('<pre>');
            print_r($itemdata['max_driving']);
            print_r('</pre>');
            print_r('<pre>');
            print_r($itemdata['min_cont_rest_period']);
            print_r('</pre>');
            print_r('<pre>');
            print_r('<pre>');
            print_r("********daily melumatlar************");
            print_r('</pre>');
            $cont_driving_time=0;
            $$max_driving=0;
            $min_cont_rest_period=0;
            $totaldailyviol=0;
          }
          print_r('<pre>');
          print_r("-------daily cem------------");
          print_r('</pre>');
          print_r('<pre>');
          print_r($items[0]['driver']);
          print_r('</pre>');
          print_r('<pre>');
          print_r($sumtotaldailyviol);
          print_r('</pre>');
          print_r('<pre>');
          print_r("-------daily cem------------");
          print_r('</pre>');
        }
      }


      //---END---Gündəlik qayda pozuntularını toplayaq---

      //---BEGIN---Həftəlik qayda pozuntularını toplayaq---
      $sumtotalweeklyviol=0;
      foreach ( $GLOBALS['fatigueweeklyresult'] as $items ) {
        if($items[0]['drivercode']==$unit){
          foreach ( $items as $itemdata ) {
            $min_notdriving_break_inweek=$itemdata['min_notdriving_break_inweek']*60;
        
            $sumtotalweeklyviol+=$min_notdriving_break_inweek;

            print_r('<pre>');
            print_r("********weekly melumatlar************");
            print_r('</pre>');
            print_r('<pre>');
            print_r($itemdata['min_notdriving_break_inweek']*60);
            print_r('</pre>');
            print_r('<pre>');
            print_r("********weekly melumatlar************");
            print_r('</pre>');

            $min_notdriving_break_inweek=0;
       
          }
          print_r('<pre>');
          print_r("-------weekly cem------------");
          print_r('</pre>');
          print_r('<pre>');
          print_r($items[0]['driver']);
          print_r('</pre>');
          print_r('<pre>');
          print_r($sumtotalweeklyviol);
          print_r('</pre>');
          print_r('<pre>');
          print_r("-------weekly cem------------");
          print_r('</pre>');
        }
      }
      //---END---Həftəlik qayda pozuntularını toplayaq---

      $sumtotalall=$sumtotaldailyviol+ $sumtotalweeklyviol;

      print_r('<pre>');
      print_r("-------daily+weekly------------");
      print_r('</pre>');
      print_r('<pre>');
      print_r($items[0]['driver']);
      print_r('</pre>');
      print_r('<pre>');
      print_r($sumtotalall);
      print_r('</pre>');
      print_r('<pre>');
      print_r("-------daily+weekly------------");
      print_r('</pre>');

      $report=array();
      // $units=array();
      $report['vehicle']=$array[0][0]['c'][0];
      $report['site_name']=$groupname;
      $report['distance']=$array[3][0]['c'][1];
     
      $report['dec_penalty']=$dec_penalty;
      $report['dec']=$array[2][0]['c'][2];
      $report['dec_with_penalty_point']=$report['dec']*$dec_penalty;
      $report['dec_score']=0;
      
      $report['acc_penalty']=$acc_penalty;
      $report['acc']=$array[1][0]['c'][2];
      $report['acc_with_penalty_point']=$report['acc']*$acc_penalty;
      $report['acc_score']=0;

      $report['hos_penalty']=$hos_penalty;
      $report['HOS']=round($sumtotalall,2);
      if($report['HOS']!=null){
        $report['HOS_decimal_to_time']= minute_to_hhmmss($report['HOS']);
      }else{
        $report['HOS_decimal_to_time']="0:00:00";
      }
      $report['HOS_with_penalty_point']=round($sumtotalall*$hos_penalty,2);
      $report['HOS_score']=0;
      
      $report['overspeed_penalty']=$overspeed_penalty;
      $report['speed_dur']=$array[0][0]['c'][2];
      list($h, $m, $s) = explode(':', $report['speed_dur']);
      $second=($h * 3600) + ($m * 60) + $s;
      $report['speed_with_penalty_point']= $second*$overspeed_penalty;  
      $report['speed_score']=0;
      
      echo ' '.$report['distance'].' ';
      if ($report['distance']!='0.00' && $report['distance']!=' 0.00' && $report['distance']!='0.00 ' && $report['distance']!=' 0.00 ') {
        $report['dec_score']=round(($report['dec_with_penalty_point']*100)/$report['distance'],2);
        $report['acc_score']=round(($report['acc_with_penalty_point']*100)/$report['distance'],2);
        $report['speed_score']=round(($report['speed_with_penalty_point']*100)/($report['distance']*60),2);
        $report['HOS_score']=round(($report['HOS_with_penalty_point']*100)/($report['distance']*10),2);
      }
      $report['rag_score']=$report['dec_score']+$report['acc_score']+$report['speed_score']+ $report['HOS_score'];
        return $report;
 }
    
   function findUnitName($unit_id)
   {
      foreach ($GLOBALS['unit_all'][0] as $key => $value) 
      {
        if ($value['id']==$unit_id) 
        {
          return $value['nm'];
        }
      }
   }

   function writeExcel($tableExcel,$email="",$from,$to)
   {

      $fromslash = date('d/m/Y',$from);
      $toslash = date('d/m/Y',$to);
      $fromdefis = date('Y-m-d',$from);
      $todefis = date('Y-m-d',$to);
      $objPHPExcel = new Spreadsheet();
      $objPHPExcel->getProperties()->setCreator("Nicat Talibov")
                         ->setLastModifiedBy("Nicat Talibov")
                         ->setTitle("PHPExcel Test Document")
                         ->setSubject("PHPExcel Test Document")
                         ->setDescription("Test document for PHPExcel, generated using PHP classes.")
                         ->setKeywords("office PHPExcel php")
                         ->setCategory("Test result file");

            $objPHPExcel->getActiveSheet()->getStyle('A1:R1100')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_LEFT);
            $objPHPExcel->getActiveSheet()->getStyle('A13:R13')->getBorders()->getAllBorders()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN)
                              ->getColor()
                              ->setRGB('000000');
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A1:R1');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A1', 'Driver Scorecard Report');
            $objPHPExcel->getActiveSheet()->getStyle('A1')->getFont()->setSize(18)->setBold(true);;
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A2:R2');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A2', 'DSV ONLY (Multiple time zone)');
            $objPHPExcel->getActiveSheet()->getStyle('A2')->getFont()->setSize(14);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A3:R3');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A3', 'From '.$fromslash.' To '.$toslash);
            $objPHPExcel->getActiveSheet()->getStyle('A3')->getFont()->setSize(10);

            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A5:C5');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A5', 'Scorecard Settings');
            $objPHPExcel->getActiveSheet()->getStyle('A5')->getFont()->setSize(10);
            $objPHPExcel->getActiveSheet()->getRowDimension(5)->setRowHeight('25');
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('D5:E5');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('D5', 'Harsh Braking');
            $objPHPExcel->getActiveSheet()->getStyle('D5')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('F5:G5');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('F5', 'Harsh Acceleration');
            $objPHPExcel->getActiveSheet()->getStyle('F5')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('H5:I5');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('H5', 'Over Speeding');
            $objPHPExcel->getActiveSheet()->getStyle('H5')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('J5:K5');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('J5', 'HOS Exceeding Driving Hours Duration');
            $objPHPExcel->getActiveSheet()->getStyle('J5')->getFont()->setSize(10);

            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A6:C6');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A6', 'Penalty Points');
            $objPHPExcel->getActiveSheet()->getStyle('A6')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('D6:E6');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('D6', $tableExcel[0]['dec_penalty']);
            $objPHPExcel->getActiveSheet()->getStyle('D6')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('F6:G6');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('F6', $tableExcel[0]['acc_penalty']);
            $objPHPExcel->getActiveSheet()->getStyle('F6')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('H6:I6');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('H6', $tableExcel[0]['overspeed_penalty']);
            $objPHPExcel->getActiveSheet()->getStyle('H6')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('J6:K6');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('J6', $tableExcel[0]['hos_penalty']);
            $objPHPExcel->getActiveSheet()->getStyle('J6')->getFont()->setSize(10);

            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A7:C7');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A7', 'Cumulative Duration In Violation (sec)');
            $objPHPExcel->getActiveSheet()->getStyle('A7')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('D7:E7');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('D7', '-');
            $objPHPExcel->getActiveSheet()->getStyle('D6')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('F7:G7');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('F7','-');
            $objPHPExcel->getActiveSheet()->getStyle('F7')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('H7:I7');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('H7', '60');
            $objPHPExcel->getActiveSheet()->getStyle('H7')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('J7:K7');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('J7', '600');
            $objPHPExcel->getActiveSheet()->getStyle('J7')->getFont()->setSize(10);

            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A9:K9');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A9', 'Scoring Threshold');
            $objPHPExcel->getActiveSheet()->getStyle('A9')->getFont()->setSize(10);
            $objPHPExcel->getActiveSheet()->getStyle('A9:K9')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER);
            
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('A10:C10');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('A10', 'Green Band <2');
            $objPHPExcel->getActiveSheet()->getStyle('A10')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('D10:E10');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('D10','Amber Band  2 to 5');
            $objPHPExcel->getActiveSheet()->getStyle('D10')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('F10:H10');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('F10', 'Red Band > 5');
            $objPHPExcel->getActiveSheet()->getStyle('F10')->getFont()->setSize(10);
            $objPHPExcel->setActiveSheetIndex(0)->mergeCells('I10:K10');
            $objPHPExcel->setActiveSheetIndex(0)->setCellValue('I10', 'Speed measure: Fixed Speed');
            $objPHPExcel->getActiveSheet()->getStyle('I10')->getFont()->setSize(10);

            $objPHPExcel->getActiveSheet()->getStyle('A5:K7')->getBorders()->getAllBorders()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN)
                              ->getColor()
                              ->setRGB('000000');
            $objPHPExcel->getActiveSheet()->getStyle('A9:K10')->getBorders()->getAllBorders()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN)
                              ->getColor()
                              ->setRGB('000000');     
            $objPHPExcel->getActiveSheet()->getStyle('A10:C10')->getFill()->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)->getStartColor()->setARGB('91ED91');
            $objPHPExcel->getActiveSheet()->getStyle('D10:E10')->getFill()->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)->getStartColor()->setARGB('FFA200');
            $objPHPExcel->getActiveSheet()->getStyle('F10:H10')->getFill()->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)->getStartColor()->setARGB('FF0000');                               
            $objPHPExcel->getActiveSheet()->getStyle('A5:K5')->getFill()->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)->getStartColor()->setARGB('b1d8ca');
            $objPHPExcel->getActiveSheet()->getStyle('A9:K9')->getFill()->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)->getStartColor()->setARGB('b1d8ca');                     
            
                      
            $objPHPExcel->getActiveSheet()->getColumnDimension('A')->setWidth('6');
            $objPHPExcel->getActiveSheet()->getColumnDimension('B')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('C')->setWidth('25');
            $objPHPExcel->getActiveSheet()->getColumnDimension('D')->setWidth('25');
            $objPHPExcel->getActiveSheet()->getColumnDimension('E')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('F')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('G')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('H')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('I')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('J')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('K')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('L')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('M')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('N')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('O')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('P')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('Q')->setWidth('15');
            $objPHPExcel->getActiveSheet()->getColumnDimension('R')->setWidth('10');
            $objPHPExcel->getActiveSheet()->getRowDimension(13)->setRowHeight('60');
            $objPHPExcel->getActiveSheet()->getRowDimension(1)->setRowHeight('30');
            $objPHPExcel->getActiveSheet()->getRowDimension(2)->setRowHeight('30');
            $objPHPExcel->getActiveSheet()->getRowDimension(3)->setRowHeight('30');
            $objPHPExcel->getActiveSheet()->getStyle("B1")->getFont()->setSize(16);
            $objPHPExcel->getActiveSheet()->getStyle('A3:R13')->getFont()->setBold(true);
            $objPHPExcel->getActiveSheet()->getStyle('A13:Q13')->getFill()->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)->getStartColor()->setARGB('b1d8ca');
            $objPHPExcel->getActiveSheet()->getStyle('R13')->getFill()->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)->getStartColor()->setARGB('e4ff3a');
            // Set active sheet index to the first sheet, so Excel opens this as the first sheet
                      // echo date('H:i:s') , " Add some data" , EOL;

            // Add column headers
            $objPHPExcel->getActiveSheet()
                        ->setCellValue('A13', '№')
                        ->setCellValue('B13', 'Vehicle')
                        ->setCellValue('C13', 'Date')
                        ->setCellValue('D13', 'Site Name')
                        ->setCellValue('E13', 'Distance (km)')
                        ->setCellValue('F13', 'Harsh Braking Penalty Points')
                        ->setCellValue('G13', 'Harsh Brake Occurrences')
                        ->setCellValue('H13', 'Harsh Braking Score')
                        ->setCellValue('I13', 'Harsh Acceleration Penalty Points')
                        ->setCellValue('J13', 'Harsh Accel Occurrences')
                        ->setCellValue('K13', 'Harsh Acceleration Score')
                        ->setCellValue('L13', 'Over Speeding Penalty Points')
                        ->setCellValue('M13', 'Over Speeding Duration (hh:mm:ss)')                     
                        ->setCellValue('N13', 'Over Speeding Score')
                        ->setCellValue('O13', 'HOS Exceeding Driving Hours Penalty Points')
                        ->setCellValue('P13', 'HOS Exceeding Driving Hours Duration (hh:mm:ss)')
                        ->setCellValue('Q13', 'HOS Exceeding Driving Hours Score')
                        ->setCellValue('R13', 'Total Score');
                       
            $objPHPExcel->getActiveSheet()->getStyle('A13:R13')->getAlignment()->setWrapText(true); 
            $objPHPExcel->getActiveSheet()->getStyle('A13:R13')->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_CENTER); 
            $objPHPExcel->getActiveSheet()->getStyle('A13:R13')->getAlignment()->setVertical(\PhpOffice\PhpSpreadsheet\Style\Alignment::VERTICAL_CENTER);


      //setir datalari yazmaq
                  $cell_position[0]='A';
                  $cell_position[1]='B';
                  $cell_position[2]='C';
                  $cell_position[3]='D';
                  $cell_position[4]='E';
                  $cell_position[5]='F';
                  $cell_position[6]='G';
                  $cell_position[7]='H';
                  $cell_position[8]='I';
                  $cell_position[9]='J';
                  $cell_position[10]='K';
                  $cell_position[11]='L';
                  $cell_position[12]='M';
                  $cell_position[13]='N';
                  $cell_position[14]='O';
                  $cell_position[15]='P';
                  $cell_position[16]='Q';
                  $cell_position[17]='R';
      $counter=13;
      $number=0;            
      foreach ($tableExcel as $key => $value) {
        $counter++;
        $number++;
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[0].($counter),$number);
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[1].($counter),$value['vehicle']);
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[2].($counter),$fromslash.'-'.$toslash);
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[3].($counter),$value['site_name']);
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[4].($counter),$value['distance']);
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[5].($counter),$value['dec_with_penalty_point']);  
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[6].($counter), $value['dec']);
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[7].($counter),$value['dec_score']);
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[8].($counter),$value['acc_with_penalty_point']);
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[9].($counter),$value['acc']);
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[10].($counter),$value['acc_score']);
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[11].($counter),$value['speed_with_penalty_point']);
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[12].($counter),$value['speed_dur']);  
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[13].($counter),$value['speed_score']);  
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[14].($counter),$value['HOS_with_penalty_point']);  
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[15].($counter),$value['HOS_decimal_to_time']);  
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[16].($counter),$value['HOS_score']);  
        $objPHPExcel->setActiveSheetIndex(0)->setCellValue($cell_position[17].($counter),$value['rag_score']); 
        
        $objPHPExcel->getActiveSheet()->getStyle($cell_position[0].($counter).':'.$cell_position[17].($counter))->getAlignment()->setHorizontal(\PhpOffice\PhpSpreadsheet\Style\Alignment::HORIZONTAL_LEFT); 
        $objPHPExcel->getActiveSheet()->getStyle($cell_position[0].($counter).':'.$cell_position[17].($counter))->getAlignment()->setVertical(\PhpOffice\PhpSpreadsheet\Style\Alignment::VERTICAL_CENTER);
        $objPHPExcel->getActiveSheet()->getStyle($cell_position[0].($counter).':'.$cell_position[17].($counter))
                               ->getBorders()
                               ->getAllBorders()->setBorderStyle(\PhpOffice\PhpSpreadsheet\Style\Border::BORDER_THIN)
                               ->getColor()
                               ->setRGB('000000');
                    // for row color
        if ($number%2==0) {
          $objPHPExcel->getActiveSheet()->getStyle($cell_position[0].($counter).':'.$cell_position[16].($counter))
                                ->getFill()
                                ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
                                ->getStartColor()->setARGB('FDE8FF');
        }else{
          $objPHPExcel->getActiveSheet()->getStyle($cell_position[0].($counter).':'.$cell_position[16].($counter))
                                ->getFill()
                                ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
                                ->getStartColor()->setARGB('FFFFFF');
        }

        if ($value['rag_score']<2) {
          $objPHPExcel->getActiveSheet()->getStyle($cell_position[17].($counter))->getFill()
            ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
            ->getStartColor()->setARGB('91ED91'); 
        }else if ($value['rag_score']>=2&&$value['rag_score']<=5) {
          $objPHPExcel->getActiveSheet()->getStyle($cell_position[17].($counter))->getFill()
            ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
            ->getStartColor()->setARGB('FFA200');                      
        }else{
          $objPHPExcel->getActiveSheet()->getStyle($cell_position[17].($counter))->getFill()
            ->setFillType(\PhpOffice\PhpSpreadsheet\Style\Fill::FILL_SOLID)
            ->getStartColor()->setARGB('FF0000');

        }  
      }          
      

      $fileName = 'excel/' . 'Holcim-' .$fromdefis.' - '.$todefis. '-RAG-Report'. '.xlsx';

      $writer = new Xlsx($objPHPExcel);
      $writer->save($fileName);

      sendMail($email, $fileName, "RAG Report",$fromdefis, $todefis,"","",$path=false);

   }

    function explode_time($time) 
    { //explode time and convert into seconds

      $time = explode(':', $time);

      $time = $time[0] * 3600 + $time[1] * 60+ $time[2];

      return $time;

    }

    function minute_to_hhmmss($minute) {
      $seconds=$minute*60;
      $t = round($seconds);
      return sprintf('%02d:%02d:%02d', ($t/3600),($t/60%60), $t%60);
    }


    report();
 ?>





 
