<?php 
ini_set('display_errors', true);
include 'weeklyviolations.php';
include 'createexcel.php';
include_once 'database/db.php';
include __DIR__ . "/sendMail.php";

date_default_timezone_set('Asia/Baku');
$lastweekbegin = date('d.m.Y 00:00:00',time() - 60 * 60 * 24 * 7);
$lastweekend = date('d.m.Y 23:59:59',time() - 60 * 60 * 24);


$dbweeklyconfigviolation= new Database("localhost","aasfle5_HolcimFatigueUser","ggUsjQl&Oa.[","aasfle5_HolcimFatigue");
        
//---BEGIN---Qayda pozuntusunu təyin edən Configurations cədvəlini yükləyək. Eger should_processed_weekly_violation = 1 dirsə deməli həftəlik qayda pozuntuları nəzərə alınmalıdır---
$configwhere="active=1";
$allconfigurations=$dbweeklyconfigviolation->select("Configurations", $configwhere, NuLL ,1);
$should_processed_weekly_violation=$allconfigurations[0]['should_processed_weekly_violation'];
if( $should_processed_weekly_violation == 1){
                
    //1.Keçən həftə üçün Trips və GeoDuties cədvəllərindən qayda pozuntularını tapıb Database-ə(WeeklyWiolations) yazaq
    $runweeklyviolations=new weeklyviolations();
    $answerweeklyviolations=$runweeklyviolations->runprosess($lastweekbegin,$lastweekend);
    
    
    //2.Keçən həftə üçün WeeklyWiolations(Həftəlik qayda pozuntuları) cədvəlindəki materialları excelə yığaq.(Amma əvvəlcə bundan qabaqki mərhələinin müvəffəqiyyətlə tamamlanıb-tamamlanmadığını yoxlayaq)
    if($answerweeklyviolations){
        $runcreatexcel=new createexcel();
        $answerexcel=$runcreatexcel->runweeklyexcel($lastweekbegin,$lastweekend);
    }else{
        print_r("<pre>");
        print_r("Həftəlik qayda pozuntularının yazılmasında problem yaşandı");
        print_r("</pre>");
        die();
    }
    
    
    //3.Keçən gün üçün hazırlanmış exceli emaillərə göndərək.(Amma əvvəlcə bundan qabaqki mərhələinin müvəffəqiyyətlə tamamlanıb-tamamlanmadığını yoxlayaq)
    if($answerexcel!=null){
        $emails=getemails();
        $fileName=$answerexcel;
        sendMail($emails, $fileName, "WEEKLY HOLCIM FATIGUE",$lastweekbegin, $lastweekend,$path=false);
    }else{
        print_r("<pre>");
        print_r("Exceldə problem var");
        print_r("</pre>");
        die();
    }
}
    


//---BEGIN---Database-dən emailləri əldə etmək---
function getemails(){
    include_once 'database/db.php';
    $dbgetmails= new Database("localhost","aasfle5_HolcimFatigueUser","ggUsjQl&Oa.[","aasfle5_HolcimFatigue");
    $emaildatas=$dbgetmails->select("Emails");
    $emailsnames=array();
    foreach ($emaildatas as $key => $value) {
        array_push($emailsnames, $value['name']);
    }
    unset($dbgetmails);
    return $emailsnames;
}
//---END---Database-dən emailləri əldə etmək---

?>