<?php



class weeklyviolations

{

    public function runprosess($fromdate,$todate){

        include_once 'database/db.php';
        include 'wialon.php';
        include 'Wialon/wialon.php';
        include 'getholcimtoken.php';

        $tokenholcim=new getholcimtoken();
        $token=$tokenholcim->gettoken();
        $wialon=new WialonApi($token);
  
        $dbweeklyyviolation= new Database("localhost","aasfle5_HolcimFatigueUser","ggUsjQl&Oa.[","aasfle5_HolcimFatigue");


        //Database-dəki Trips cədvəlindən əldə olunan məlumatların filtr olunaraq WeeklyViolations cədvəlinə yazılması


        //---BEGIN---Məlumatların Trips cədvəlindən bura yükləmə prosesi---

        //Zaman aralığı seçək

        $fromdate = date('Y-m-d 00:00:00',strtotime($fromdate));

        $todate = date('Y-m-d 23:59:59',strtotime($todate));



        //Zaman filtri etmək üçün Query hazırlayaq

        $tripwhere="begin>='".$fromdate."' and end<='".$todate."'";


        //Sürücülərə və zamana görə sort etmək üçün Query hazırlayaq

        $tripOrderby="`"."drivercode"."`".","."`"."begin"."`"." ASC";



        //Məlumatları Trips cədvəlindən bura yükləyək

        $tripdatas=$dbweeklyyviolation->select("Trips",$tripwhere,$tripOrderby);
        //---END---Məlumatları Trips cədvəllərindən bura yükləmə prosesi---


        //---BEGIN---İstisna olunacaq unit-lər qrupunun id-ni database-dən tapıb, həmin unitləri trip məlumatlarının tərkibindən  çıxardaq---

        //Configurations-dan istisna olunacaq unit qruplarının id-ni əldə edək
        $allconfigurations = $dbweeklyyviolation->select("Configurations","active=1",NuLL ,1);
        $group_free_from_weekly_wiolation=$allconfigurations[0]['group_free_from_weekly_wiolation'];
        $group_free_from_all_wiolation=$allconfigurations[0]['group_free_from_all_wiolation'];

        
        //İstisna olunacaq unitlər qruplarının melumatlarını Wialondan əldə edək
        $units_bygroup=$wialon->unit_groupby_id($group_free_from_weekly_wiolation);
        $units_bygroup_allviolation=$wialon->unit_groupby_id($group_free_from_all_wiolation);


        //Tripin məlumatlarından bu unit-lərə məxsus tripləri çıxardaq
        if($units_bygroup!=NuLL){
            foreach ($units_bygroup['u'] as $unitid) {
                foreach ($tripdatas as $key=>$trip) {
                    if($trip['drivercode']==$unitid){
                        unset($tripdatas[$key]);
                    }     
                }
            }
        }

        if($units_bygroup_allviolation!=NuLL){
            foreach ($units_bygroup_allviolation['u'] as $unitid) {
                foreach ($tripdatas as $key=>$trip) {
                    if($trip['drivercode']==$unitid){
                        unset($tripdatas[$key]);
                    }     
                }
            }
        }
      
        //---END---İstisna olunacaq unit-lər qrupunun id-ni database-dən tapıb, həmin unitləri trip məlumatlarının tərkibindən  çıxardaq---


        //---BEGIN---Lazımi bütün hazırlıq görüldüyü üçün prosedura başlamaq olar---
        //Prosedurda istifadə olunan dəyişənləri daxil edək

        $niko2=array();



        //Sürücünün adına görə qruplaşdı

        $groupbydriver = array();

        foreach ($tripdatas as $value ) {

            if (isset($value['driver'])) {

                if($value['driver']!=null){

                    $groupbydriver[$value['driver']][] = $value;

                }  

            }

        }





        //Sürücüləri dövrə salaq

        foreach ( $groupbydriver as $driveritem ){

            //Trip və Geoduties arraylərini birləşdirib,daha sonra sürücüyə görə qruplaşdırmışdıq.İndi isə hər sürücünün etdiyi Triplərin sayını tapaq

            $restcollections=array();   //Bütün breakləri bir yerə yığmaq üçün siyahı

            //Sürüclərin Triplərini dövrə salaq

            foreach ( $driveritem as $key=>$item ){

                    //Həftə ərzindəki bütün breakləri bir siyahıya yığaq ki, onların arasından limiti aşanı(Həftə ərzində minimal dincəlmə limiti=24saat) təyin edə bilək.Əgər limiti aşılıbsa nə qədər olunduğu bilinməlidir(Düstur=limit - real)

                    if($key==0 && count($driveritem)!=1){

                        //Birinci break həftənin başlanğıcından ilk tripin başlama vaxtına kimi olan müddətdir
                       
                        $restlement=strtotime($item['begin'])-strtotime($fromdate);

                        array_push($restcollections, $restlement);					

                    }

                    elseif($key==0 && count($driveritem)==1){
                        
                        //Birinci break həftənin başlanğıcından yeganə tripin başlama vaxtına kimi olan müddətdir

                        $restlement=strtotime($item['begin'])-strtotime($fromdate);

                        array_push($restcollections, $restlement);  

                        //Sonuncu break yeganə tripin bitməsindən günün sonuna(23:59) qədər olan müddətdir

                        $restlement=strtotime($todate)-strtotime($item['end']);

                        array_push($restcollections, $restlement);
                    }


                    elseif($key==count($driveritem)-1){
            
                        //Sonuncu break sonuncu tripin bitməsindən günün sonuna(23:59) qədər olan müddətdir

                        $restlement=strtotime($todate)-strtotime($item['end']);

                        array_push($restcollections, $restlement);

                        //Sonuncudan onceki break isə sonuncu tripin başlama müddəti ilə öncəki tripin bitmə müddətinin fərqinə bərabərdir

                        $restlement=strtotime($driveritem[$key]['begin'])-strtotime($driveritem[$key-1]['end']);

                        array_push($restcollections, $restlement);

                    }

                    else{

                        //Arada olan breaklər isə yeni tripin başlama müddəti ilə öncəki tripin bitmə müddətinin fərqinə bərabərdir

                        $restlement=strtotime($driveritem[$key]['begin'])-strtotime($driveritem[$key-1]['end']);

                        array_push($restcollections, $restlement);
                    

                    }

            }



            //Break-lərin siyahısında qayda pozuntusu olub-olmadığını araşdıraq

            $enaughrest=null;

            rsort($restcollections); 

            print_r("<pre>");

            print_r($restcollections);

            print_r("</pre>");

            if(!empty($restcollections)){

                if($restcollections[0]<=86400){

                    $enaughrest=abs(86400 - $restcollections[0])/3600;                 

                }else{

                	$enaughrest=null;  //Limit pozulmayıb

                }

            }

 				

            $niko2['drivercode']=$item['drivercode'];

            $niko2['driver']=$item['driver'];

            $niko2['min_notdriving_break_inweek']=$this->decimal_to_time($enaughrest);

            $niko2['week_begin']=date('Y-m-d',strtotime($fromdate));

            $niko2['week_end']=date('Y-m-d',strtotime($todate));



            //Məlumatları Database-ə yazaq

            $dv_drivercode=$item['drivercode'];

            $dv_driver=$item['driver'];

            $dv_min_notdriving_break_inweek=$enaughrest;

            $dv_week_begin=date('Y-m-d',strtotime($fromdate));

            $dv_week_end=date('Y-m-d',strtotime($todate));

  

            if($dv_min_notdriving_break_inweek!=0){

                

                $data= array('drivercode' => $dv_drivercode,'driver'=> $dv_driver,'min_notdriving_break_inweek'=> $dv_min_notdriving_break_inweek,'week_begin'=> $dv_week_begin,'week_end'=> $dv_week_end);



                $dbweeklyyviolation->insert("WeeklyViolations",$data);

                $dbweeklyyviolation->disconnect();

            }



  			$enaughrest=0;

            $restcollections=[];

            print_r("<pre>");

            print_r($niko2);

            print_r("</pre>");

        }

        //---END---Lazımi bütün hazırlıq görüldüyü üçün prosedura başlamaq olar---  

        unset($dbweeklyyviolation);

        return true;

    }









	//---BEGIN---Köməkçi funksiyalar--

    //---BEGIN---Onluq formatı zaman formatına çevirmək üçün funksiya---

    public function decimal_to_time($dec){

        $seconds = ($dec * 3600);

        $hours = floor($dec);

        $seconds -= $hours * 3600;

        $minutes = floor($seconds / 60);

        $seconds -= $minutes * 60;

        return $this->lz($hours).":".$this->lz($minutes).":".$this->lz($seconds);

    }

    

    // lz = leading zero

    public function lz($num){

        return (strlen($num) < 2) ? "0{$num}" : $num;

    }

    //---END---Onluq formatı zaman formatına çevirmək üçün funksiya---

    //---END---Köməkçi funksiyalar---  



}



?>